import java.util.*;
import javax.microedition.lcdui.*;

public class  mineCanvas extends Canvas implements Runnable
{
    	Display         display;
    
	static 		    int	sqlength = 5;	// length of tetris square
	static final	int	xoffset = 43;	// distance from left
	static 		    int	cols = 10;		// columns
	static 		    int	rows = 19;		// rows
	int		        f[][]; 			// field
	int		        of[][]; 		// old field
	int		        cur_what, new_what;	// type of current piece
	Square		    curpiece[] = new Square[4];	// current piece
	Square          newpiece[] = new Square[4];
	boolean		    lost;			// lost
	boolean		    neednewpiece;		// need new piece
	Thread		    killme = null;		// thread that does gravity
	int		        curval, score=0;
	int		        level =1;			// current level of difficulty
	int		        pieces;			// nr of pieces dropped
	boolean 	    justupdating = false;
	boolean         is_start = false;

	public mineCanvas(Display dis)
	{
		display=dis;
	}

    private boolean movepiece(Square from[], Square to[]) {
        outerlabel:
	    for (int i=0; i<to.length; i++) {
	        if (!to[i].InBounds()) {
	    	    return false;
	        }

	        if (f[to[i].X()][to[i].Y()] != 0) {	// it's taken
		        for (int j=0; j<from.length; j++){
		            if(to[i].IsEqual(from[j])) {
			            continue outerlabel;		// but by a from
		            }
		        }
		            return false;	// no can do
	        }
	    }

	    for (int i=0; i<from.length; i++) 
	        if(from[i].InBounds()) {
       		    f[from[i].X()][from[i].Y()] = 0;
	        }		

	    for (int i=0; i<to.length; i++) 
	        f[to[i].X()][to[i].Y()] = to[i].Color();
        return true;
    }

    private Square[] selectNewpiece(){
        Square  temp[] = new Square[4];
        int m = cols/2;
   	    Random rand=new Random();

	    new_what = (int) rand.nextInt()%7;
	    new_what = (new_what>0) ? new_what : new_what*(-1);
        
        switch(new_what) {
	        case 0:
		        // XXXX		red
		        curval = 2;
		        temp[0] = new Square(m-1, rows-1, 1, this.cols, this.rows);
		        temp[1] = new Square(m-2, rows-1, 1, this.cols, this.rows);
		        temp[2] = new Square(m,   rows-1, 1, this.cols, this.rows);
		        temp[3] = new Square(m+1, rows-1, 1, this.cols, this.rows);
		        break;
	        case 1:
		        //  X		orange
		        // XXX
		        curval = 3;
		        temp[0] = new Square(m  , rows-2, 5, this.cols, this.rows);
		        temp[1] = new Square(m  , rows-1, 5, this.cols, this.rows);
		        temp[2] = new Square(m-1, rows-2, 5, this.cols, this.rows);
		        temp[3] = new Square(m+1, rows-2, 5, this.cols, this.rows);
		        break;
	        case 2:
		        // XX		???
		        //  XX
		        curval = 4;
		        temp[0] = new Square(m  , rows-2, 2, this.cols, this.rows);
		        temp[1] = new Square(m-1, rows-1, 2, this.cols, this.rows);
		        temp[2] = new Square(m  , rows-1, 2, this.cols, this.rows);
		        temp[3] = new Square(m+1, rows-2, 2, this.cols, this.rows);
		        break;
	        case 3:
		        //  XX		???
		        // XX 
		        curval = 4;
		        temp[0] = new Square(m  , rows-2, 7, this.cols, this.rows);
		        temp[1] = new Square(m+1, rows-1, 7, this.cols, this.rows);
		        temp[2] = new Square(m  , rows-1, 7, this.cols, this.rows);
		        temp[3] = new Square(m-1, rows-2, 7, this.cols, this.rows);
		        break;
	        case 4:
		        //  XX		light blue
		        //  XX 
		        curval = 2;
		        temp[0] = new Square(m-1, rows-1, 3, this.cols, this.rows);
		        temp[1] = new Square(m  , rows-1, 3, this.cols, this.rows);
		        temp[2] = new Square(m-1, rows-2, 3, this.cols, this.rows);
		        temp[3] = new Square(m  , rows-2, 3, this.cols, this.rows);
		        break;
	        case 5:
		        //  XXX		
		        //    X 
		        curval = 3;
		        temp[0] = new Square(m  , rows-1, 6, this.cols, this.rows);
		        temp[1] = new Square(m-1, rows-1, 6, this.cols, this.rows);
		        temp[2] = new Square(m+1, rows-1, 6, this.cols, this.rows);
		        temp[3] = new Square(m+1, rows-2, 6, this.cols, this.rows);
		        break;
	        case 6:
		        //  XXX		yellow
		        //  X  
		        curval = 3;
		        temp[0] = new Square(m  , rows-1, 4, this.cols, this.rows);
		        temp[1] = new Square(m+1, rows-1, 4, this.cols, this.rows);
		        temp[2] = new Square(m-1, rows-1, 4, this.cols, this.rows);
		        temp[3] = new Square(m-1, rows-2, 4, this.cols, this.rows);
		        break;
	    }
	    return temp;
    }
    
    private void newpiece() 
    {
	    Square  old[] = new Square[4];
	    old[0] = old[1] = old[2] = old[3] = new Square(-1, -1, 0, this.cols, this.rows);
        this.curpiece = this.newpiece;
        this.cur_what = this.new_what;
        this.newpiece = selectNewpiece();
	    lost = !movepiece(old, curpiece);
	}

    private synchronized boolean movecurpiece(int byx, int byy, boolean rotate) {
	    Square newpos[] = new Square[4];

	    for(int i=0; i<4; i++) {
	        if(rotate) {
    		    int dx = curpiece[i].X() - curpiece[0].X();
	    	    int dy = curpiece[i].Y() - curpiece[0].Y();
		        newpos[i] = new Square(	curpiece[0].X() - dy,
				   	curpiece[0].Y() + dx,
				   	curpiece[i].Color(), this.cols, this.rows);
	        } else
		        newpos[i] = new Square(	curpiece[i].X() + byx,
				   	curpiece[i].Y() + byy,
				   	curpiece[i].Color(), this.cols, this.rows);
	    }
	    if (!movepiece(curpiece, newpos)) 
	        return false;
	    curpiece = newpos;
    	return true;
    }

    private void removelines() {
        outerlabel:
	    for (int j=0; j<rows; j++) {
	        for (int i=0; i<cols; i++)
	    	    if (f[i][j] == 0)
		            continue outerlabel;

	        for (int k=j; k<rows-1; k++)
	            for (int i=0; i<cols; i++)
		            f[i][k] = f[i][k+1];
	        j--;
	    }
    }

    public void  newGame() {	
        
        this.stop();
        
	    sqlength = 5;
	    cols = 10;
        rows = 19;

	    f = new int[cols][rows+4];	
	    of = new int[cols][rows+4];	

	    for(int i=0; i<cols; i++)
	        for(int j=0; j<rows+4; j++) {
		        f[i][j] = 0; 
		        of[i][j] = -1;
	        }
	    
    	level = 1;
	    score = 0;
	    pieces= 0;
	    curval = -1;
	    neednewpiece = true;
	    this.newpiece = this.selectNewpiece();
	    lost = false;

	    this.is_start = false;
        (killme = new Thread(this)).start();
    }

	public void start()
	{
		display.setCurrent(this);
		this.is_start = true;
		repaint();
	}

    public synchronized void stop() {
        if(this.killme != null && this.killme.isAlive()){
            this.killme = null;
            this.lost = true;
        }
    }

    public void run(){
        while (!lost){
	        try {
		        int t = level == 1 ? 400 : 
		            level == 2 ? 370 :
		            level == 3 ? 330 :
		            level == 4 ? 300 :
		            level == 5 ? 270 :
		            level == 6 ? 250 :
		            level == 7 ? 230 :
		            level == 8 ? 200 :
		            level == 9 ? 170 :
		            level == 10 ? 130 : 100;
		        Thread.sleep(t);
	        } catch (InterruptedException e){}
	
	        if (neednewpiece) {
		        if(curval > 0) {
		            score += curval;
		            pieces++;
		            level = 1 + pieces/30;
		        }
		        removelines();
		        newpiece();
		        neednewpiece = false;
	        } else {
		        neednewpiece = !movecurpiece(0, -1, false);	
	        }
	        repaint();
	    }
	    killme = null;
    }

    public void keyPressed(int keycode){
	  
    	int action=getGameAction(keycode);

		switch(action)
		{
			case FIRE:
				break;			

	        case LEFT:
		            movecurpiece(-1, 0, false);
		            neednewpiece = false;
		            repaint();
		            break;

	        case RIGHT:
		            movecurpiece(1, 0, false);
		            neednewpiece = false;
		            repaint();
		            break;

	        case UP:
		            if(cur_what!=4) {
		                movecurpiece(0, 0, true);
		                repaint();
		            }
		            break;

	        case DOWN:
		            while(movecurpiece(0, -1, false));
		            repaint();
		            break;
	    }
    }

    public void update(Graphics g){
	    justupdating = true;
	    paint(g);
    }

    public synchronized void paint(Graphics g){
      try{ 
        if(is_start){
            g.setFont(Font.getFont(Font.FACE_SYSTEM,Font.STYLE_ITALIC ,Font.SIZE_MEDIUM));
	        g.drawString("JAVA TETRIS",10, 40, 20 );
	        g.drawRect(0,0,95,99);
        }else {
          
	    this.setSqlColor(g, 0);
            g.fillRect(0,0,95,99);
            this.setSqlColor(g, 8);
	        g.drawRect(0,0,95,99);
	        g.drawRect(xoffset-1, 2, sqlength*cols+1, sqlength*rows+1);
            this.setSqlColor(g, 8);
            g.setFont(Font.getFont(Font.FACE_SYSTEM,Font.STYLE_PLAIN,Font.SIZE_SMALL));
	        g.drawString("Score", 3, 40, 20);
	        g.drawString(""+score, 3, 55, 20);
	        g.drawString("Level", 3, 70, 20);
	        g.drawString(""+level, 3, 85, 20);
	        this.drawNextPiece(g);
        
	        for (int i=0; i<cols; i++)
	            for (int j=0; j<rows; j++) {
		            if (!justupdating ||of[i][rows-1-j] == -1 || of[i][rows-1-j] != f[i][rows-1-j]) {
                        this.setSqlColor(g, f[i][rows-1-j]);		    	    
		    	        g.fillRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
		    	        this.setSqlColor(g, 0);
		    	        g.drawRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
		            }
		            of[i][rows-1-j] = f[i][rows-1-j];
	            }
	        justupdating = false;
	}
       }catch(Exception e){
	System.out.println(e.getMessage());
	System.out.println(e.toString());
       }
    }
    
    private void drawNextPiece(Graphics g){
        g.drawString("Next piece" , 3, 5, 20);
        int startx= 8, starty=22;
        
        switch(new_what) {
	        case 0:
		        // XXXX		red
		    	g.fillRect(startx, starty+3, sqlength*4, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx, starty+3, sqlength, sqlength);
		    	g.drawRect(startx+sqlength, starty+3, sqlength, sqlength);
		    	g.drawRect(startx+sqlength*2, starty+3, sqlength, sqlength);
		    	g.drawRect(startx+sqlength*3, starty+3, sqlength, sqlength);
		        break;
	        case 1:
		        //  X		orange
		        // XXX
		    	g.fillRect(startx +sqlength+3, starty, sqlength, sqlength);
		    	g.fillRect(startx+3, starty+sqlength, sqlength*3, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
		    	g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
		        g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
		        break;
            case 2:
		        // XX		???
		        //  XX
		      	g.fillRect(startx +3, starty, sqlength*2, sqlength);
               	g.fillRect(startx+sqlength+3, starty+sqlength, sqlength*2, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx+3, starty, sqlength, sqlength);
		    	g.drawRect(startx+sqlength+3, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);

		        break;
	        case 3:
		        //  XX		???
		        // XX 
		    	g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength);
		    	g.fillRect(startx+3, starty+sqlength, sqlength*2, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
		    	g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
		        break;
	        case 4:
		        //  XX		light blue
		        //  XX 
		    	g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
		    	g.drawLine(startx +sqlength*2+3, starty, startx +sqlength*2+3, starty+sqlength*2);
		    	g.drawLine(startx +sqlength+3, starty+sqlength, startx +sqlength*3+3, starty+sqlength);

		        break;
	        case 5:
		        //  XXX		
		        //    X 
		    	g.fillRect(startx +3, starty, sqlength*3, sqlength);
		    	g.fillRect(startx+sqlength*2+3, starty+sqlength, sqlength, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx+3, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
                g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
		        break;
	        case 6:
		        //  XXX		yellow
		        //  X  
		    	g.fillRect(startx +3, starty, sqlength*3, sqlength);
		    	g.fillRect(startx+3, starty+sqlength, sqlength, sqlength*1);
		    	this.setSqlColor(g, 0);
		    	g.drawRect(startx+3, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
		    	g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
                g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
		        break;
	    }
    }
    
    public void setSqlColor(Graphics g, int color){
		switch(color)
		{
			case 0: g.setColor(255,255,255);
				    break;			
/*			case 1: g.setColor(255,0,0);
				    break;			
	        case 2: g.setColor(0,200,0);
		            break;
	        case 3: g.setColor(0,200,255);
		            break;
	        case 4: g.setColor(255,255,0);
		            break;
	        case 5: g.setColor(255,150,0);
		            break;
	        case 6: g.setColor(210,0,240);
		            break;
	        case 7: g.setColor(40,0,240);
		            break;                      
	        case 8: g.setColor(0,0,0);
		            break;                      */
		    default : g.setColor(0,0,0);
		            break;
	    }
    }
}