/*
 * Copyright 1998-2000 RnDClub.net and RnDTeam.net -- all rights reserved
 *
 *   Author: Yongwoo's Park
 * Filename: /member/servlet/MemberImageServlet.java
 *     Date: 2001/05/01
 */

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.rndclub.member.*;

public class MemberImageServlet extends HttpServlet {
   public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws ServletException, IOException {
      try {
         long seqNum = Long.parseLong(request.getParameter("seqNum"));

         MemberProcessBean memberProcess = new MemberProcessBean();
         MemberBean member = memberProcess.selectImage(seqNum);

         String contentType = member.getImageType();
         InputStream imageStream = member.getImage();

         if(contentType!=null) {
            response.setContentType(contentType);
            OutputStream outStream = response.getOutputStream();
            int len=0;
            byte buf[] = new byte[512];
            do {
               len = imageStream.read(buf);
               if((len == -1)||(len == 0)) {
                  break;
               }
               outStream.write(buf, 0, len);
            } while(len == 512);
            outStream.close();
         }

      } catch(Exception e) {
         e.printStackTrace();

         request.setAttribute("exception", e);

         RequestDispatcher disp = null;
         ServletContext context = getServletContext();
         disp = context.getRequestDispatcher("/ErrorPage.jsp");
         disp.forward(request, response);
      }
   }
} 
