package org.rndclub.dbpool;

import java.sql.*;

public class ConnectionPool {
   final static String jdbcDriver="sun.jdbc.odbc.JdbcOdbcDriver";
   final static String jdbcUrl="jdbc:odbc:rndclub";
   final static String jdbcUser="sa";
   final static String jdbcPass="";

   static Connection conn=null;

   static {
      try {
         init();
      } catch(SQLException e) {
         e.printStackTrace();
      }
   }

   public ConnectionPool() throws ClassNotFoundException, SQLException {
      init();
   }

   public void finalize() throws SQLException {
      closeConnection();
   }

   public static void init() throws SQLException {
      if((conn == null)||(conn.isClosed())) {
         conn = createConnection();
      }
   }

   public static Connection createConnection()
   throws SQLException {
      Connection tempConn=null;

      try {
         Class.forName(jdbcDriver);
         tempConn = DriverManager.getConnection(jdbcUrl, jdbcUser, jdbcPass);
      } catch(ClassNotFoundException e) {
         e.printStackTrace();
      }
      return(tempConn);
   }

   public static Connection getConnection()
   throws SQLException {
      if((conn == null)||(conn.isClosed())) {
         conn = createConnection();
      }
      return(conn);
   }

   public static void closeConnection()
   throws SQLException {
      if(conn != null) {
         conn.close();
         conn = null;
      }
   }

   public static Statement createStatement()
   throws SQLException {
      Statement stmt=null;
      try {
         if((conn == null)||(conn.isClosed())) {
            conn = createConnection();
         }
   
         stmt = conn.createStatement();
      } catch(SQLException e) {
         String exStr = "CODE ["+e.getErrorCode()
                      + "], STATE ["+e.getSQLState()
                      + "], MSG ["+e.getMessage()
                      + "], CONN ["+conn+"]";

         throw new SQLException(exStr);
      }

      return(stmt);
   }

   public static PreparedStatement prepareStatement(String query)
   throws SQLException {
      PreparedStatement pstmt=null;
      try {
         if((conn == null)||(conn.isClosed())) {
            conn = createConnection();
         }

         pstmt = conn.prepareStatement(query);
      } catch(SQLException e) {
         String exStr = "CODE ["+e.getErrorCode()
                      + "], STATE ["+e.getSQLState()
                      + "], MSG ["+e.getMessage()
                      + "], CONN ["+conn+"]";

         throw new SQLException(exStr);
      }

      return(pstmt);
   }
}
