package org.rndclub.guestbook;

import java.sql.*;
import java.util.*;
import java.text.SimpleDateFormat;
import org.rndclub.dbpool.ConnectionPool;

public class GuestBookProcess {
   int rowPerPage=10;
   int numberOfRow=0;
   int numberOfPage=0;

   public int getNumberOfRow() {
      return(numberOfRow);
   }

   public int getNumberOfPage() {
      return(numberOfPage);
   }

   public int getRowPerPage() {
      return(rowPerPage);
   }

   public void setRowPerPage(int rowPerPage) {
      this.rowPerPage = rowPerPage;
   }

   public boolean availablePage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if((pageNum >= 1)&&(pageNum <= numberOfPage)) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availablePrevPage(int pageNum) {
      if(pageNum > 1) {
         return(true);
      } else {
         return(false);
      }
   }

   public boolean availableNextPage(int pageNum) {
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if(pageNum < numberOfPage) {
         return(true);
      } else {
         return(false);
      }
   }

   public void insert(GuestBookBean gb) throws SQLException {
      Statement stmt = ConnectionPool.createStatement();
      java.sql.Date date = new java.sql.Date(System.currentTimeMillis());

      SimpleDateFormat smt = new SimpleDateFormat("yyyy-MM-dd");
      String dateStr = smt.format(new java.util.Date());

      String query = "INSERT INTO Guestbook "
                   + "(name, password, subject, content, email, homepage, writedate, refCount) "
                   + "VALUES ("
                   + "'" + gb.getName() + "', "
                   + "'" + gb.getPassword() + "', "
                   + "'" + gb.getSubject() + "', "
                   + "'" + gb.getContent() + "', "
                   + "'" + gb.getEmail() + "', "
                   + "'" + gb.getHomepage() + "', "
                   + "'" + dateStr + "', 0)";
//    + "getdate(), 0)";

      if(stmt.executeUpdate(query) < 1) {
         throw new SQLException("[Guestgbook] Insert failed");
      }
      stmt.close();
   }

   public ArrayList selectPage(int pageNum) throws SQLException {
      ArrayList gbList = new ArrayList();

      Statement stmt = ConnectionPool.createStatement();
      String query = "SELECT count(id) as numberOfRow FROM Guestbook";
      ResultSet rs = stmt.executeQuery(query);
      if(rs.next()) {
         numberOfRow = rs.getInt("numberOfRow");
      } else {
         numberOfRow = 0;
      }
      numberOfPage = ((numberOfRow-1) / rowPerPage) + 1;

      if(!availablePage(pageNum)) {
         pageNum = 1;
      }

      rs.close();

      query = "SELECT id, name, password, subject, content, email, homepage, writedate, refCount "
            + "FROM Guestbook "
            + "ORDER BY id DESC";
      rs = stmt.executeQuery(query);
      for(int i=0;i<((pageNum-1) * rowPerPage);i++) {
         if(!rs.next()) {
            throw new SQLException("[Guestgbook] ResultSet is out of index");
         }
      }

      for(int i=0;i<rowPerPage;i++) {
         if(!rs.next()) {
            break;
         }
         GuestBookBean gb = new GuestBookBean();

         gb.setId(rs.getInt("id"));
         gb.setName(rs.getString("name"));
         gb.setPassword(rs.getString("password"));
         gb.setSubject(rs.getString("subject"));
         gb.setContent(rs.getString("content"));
         gb.setEmail(rs.getString("email"));
         gb.setHomepage(rs.getString("homepage"));
         gb.setWriteDate(rs.getDate("writedate").toString());
         gb.setRefCount(rs.getInt("refCount"));

         gbList.add(gb);
      }
      rs.close();
      stmt.close();

      return(gbList);
   }

   public ArrayList selectAll() throws SQLException {
      ArrayList gbList = new ArrayList();

      Statement stmt = ConnectionPool.createStatement();
      String query = "SELECT id, name, password, subject, content, email, homepage, writedate, refCount FROM Guestbook ORDER BY id DESC";
      ResultSet rs = stmt.executeQuery(query);

      while(rs.next()) {
         GuestBookBean gb = new GuestBookBean();

         gb.setId(rs.getInt("id"));
         gb.setName(rs.getString("name"));
         gb.setPassword(rs.getString("password"));
         gb.setSubject(rs.getString("subject"));
         gb.setContent(rs.getString("content"));
         gb.setEmail(rs.getString("email"));
         gb.setHomepage(rs.getString("homepage"));
         gb.setWriteDate(rs.getDate("writedate").toString());
         gb.setRefCount(rs.getInt("refCount"));

         gbList.add(gb);
      }
      rs.close();
      stmt.close();

      return(gbList);
   }

   public GuestBookBean select(int id)
   throws SQLException {
      Statement stmt = ConnectionPool.createStatement();

      String query = "UPDATE Guestbook SET refCount=refCount+1 WHERE id="+id;
      if(stmt.executeUpdate(query) < 1) {
         throw new SQLException("[Guestgbook] Update failed");
      }

      query = "SELECT id, name, password, subject, content, email, homepage, writedate, refCount "
            + "FROM Guestbook "
            + "WHERE id="+id;
      ResultSet rs = stmt.executeQuery(query);

      GuestBookBean gb = new GuestBookBean();
      if(rs.next()) {
         gb.setId(rs.getInt("id"));
         gb.setName(rs.getString("name"));
         gb.setPassword(rs.getString("password"));
         gb.setSubject(rs.getString("subject"));
         gb.setContent(rs.getString("content"));
         gb.setEmail(rs.getString("email"));
         gb.setHomepage(rs.getString("homepage"));
         gb.setWriteDate(rs.getString("writedate"));
         gb.setRefCount(rs.getInt("refCount"));
      }
      rs.close();
      stmt.close();

      return(gb);
   }
}
