import java.awt.*;

class TimeBar extends Canvas {
   int time, maxTime;
   Color powerColor=null, bgColor=null;

   public TimeBar(int maxTime) {
      this.maxTime = maxTime;
      time = 0;
      powerColor = new Color(0xff, 0x99, 0x00);
      bgColor = new Color(0x22, 0x22, 0x66);
      setSize(maxTime*3, 16);
   }

   int getTime() {
      return(time);
   }

   void setTime(int time) {
      this.time = time;
      repaint();
   }

   void setMaxTime(int maxTime) {
      this.maxTime = maxTime;
      repaint();
   }

   public void repaint() {
      update(getGraphics());
   }

   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      if(g == null) return;

      for(int i=0;i<time;i++) {
         if(powerColor != null) {
            g.setColor(powerColor);
         } else {
            g.setColor(Color.red);
         }
         g.drawLine(i*3, 0, i*3, 15);;
         g.drawLine(i*3+1, 0, i*3+1, 15);;
         g.setColor(Color.lightGray);
         g.drawLine(i*3+2, 0, i*3+2, 15);;
      }
      for(int i=time;i<maxTime;i++) {
         if(bgColor != null) {
            g.setColor(bgColor);
         } else {
            g.setColor(Color.lightGray);
         }
         g.drawLine(i*3, 0, i*3, 15);;
         g.drawLine(i*3+1, 0, i*3+1, 15);;
         g.setColor(Color.black);
         g.drawLine(i*3+2, 0, i*3+2, 15);;
      }

      String str = ""+time;
      FontMetrics fm = Toolkit.getDefaultToolkit().getFontMetrics(getFont());
      if((getSize().width >> 1) > time*3) {
         g.setColor(Color.white);
      } else {
         g.setColor(Color.blue);
      }
      g.drawString(str, getSize().width - fm.stringWidth(str) >> 1, 12);
   }
}
