import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import java.io.*;
import java.net.*;
import java.util.Date;

public class HiddenCatch extends Applet implements Runnable {
   final static int LEVEL_MAX=10;
   final static int LIFE_MAX=10;

   final static int IMAGE_NUM=2;
   final static int IMAGE_NUM_ROW=1;
   final static int IMAGE_NUM_COL=2;
   final static int PANEL_NUM=IMAGE_NUM_ROW*IMAGE_NUM_COL;
   static int TIMEOVER=90;
   final static int MISMATCH_DELAY=250;

   Image lifeImage=null;

   Panel gameBoard=null;
   ImageCanvas imageCanvas[]=null;
   Image images[][]=null;
   Rectangle rect[][]=null;

   Panel statusPanel=null;

   Button startStopButton=null;
   Choice imageChoice=null;
   Label lifeLabel=null;

   Label elapsedTimeLabel=null;
   Label powerLabel=null;
   Label scoreLabel=null;
   TextField scoreField=null;

   public boolean gameFlag=false;

   int matchedNum=0, selectedImage=0;
   long startTime=0, elapsedTime=0;
   Thread elapsedThread=null;
   int level=0, score=0;
   boolean hitTable[]=null;

   ProgressiveBar progressiveBar=null;
   LifeBar lifeBar=null;

   public void init() {
      gameBoard = new Panel(new GridLayout(1, 2, 4, 4));
      imageCanvas = new ImageCanvas[PANEL_NUM];

      try {
         TIMEOVER = Integer.parseInt(getParameter("timeover"));
      } catch(NumberFormatException e) {
         TIMEOVER = 90;
      }
      int imageDirs = Integer.parseInt(getParameter("imageDirs"));
      images = new Image[imageDirs][IMAGE_NUM];
      rect = new Rectangle[imageDirs][5];

      //  XP  â Frame   Ƿ
      WarningDialog dialog = new WarningDialog((Frame)this.getParent(), "Notice!",
                                               "Please wait for loading images....");
      dialog.setVisible(true);

      setLayout(new BorderLayout(4, 4));
      for(int i=0;i<PANEL_NUM;i++) {
         imageCanvas[i] = new ImageCanvas();
         imageCanvas[i].setState(ImageCanvas.STATE_BACK);
         gameBoard.add(imageCanvas[i]);
      }

      lifeBar = new LifeBar(LIFE_MAX);
      progressiveBar = new ProgressiveBar(TIMEOVER);

      statusPanel = new Panel();

      startStopButton = new Button("Start");
      imageChoice = new Choice();
      powerLabel = new Label("Power:", Label.RIGHT);
      progressiveBar = new ProgressiveBar(TIMEOVER);
      elapsedTimeLabel = new Label("000", Label.LEFT);
      scoreLabel = new Label("Score:", Label.RIGHT);
      scoreField = new TextField("0", 8);
      scoreField.setEnabled(false);
      lifeLabel = new Label("Life:");

      powerLabel.setForeground(Color.blue);
      scoreLabel.setForeground(Color.blue);
      elapsedTimeLabel.setForeground(Color.red);

      statusPanel.add(startStopButton);

      statusPanel.add(powerLabel);
      statusPanel.add(progressiveBar);
      statusPanel.add(elapsedTimeLabel);
      statusPanel.add(scoreLabel);
      statusPanel.add(scoreField);

      statusPanel.add(lifeLabel);
      statusPanel.add(lifeBar);

      add("Center", gameBoard);
      add("South", statusPanel);

      Button eastBar = new Button("");
      Button westBar = new Button("");
      Button northBar = new Button("");

      add("North", northBar);
      add("West", westBar);
      add("East", eastBar);

      northBar.setEnabled(false);
      westBar.setEnabled(false);
      eastBar.setEnabled(false);

      MediaTracker tracker = new MediaTracker(this);
      String path=null;
      hitTable = new boolean[imageDirs];
      for(int i=0;i<imageDirs;i++) {
         try {
            path = "images/" + getParameter("imageDir["+i+"]") + "/";
            URL url = new URL(getDocumentBase(), path+"game.property");

            Reader r = new BufferedReader(new InputStreamReader(url.openStream()));
            StreamTokenizer st = new StreamTokenizer(r);

            for(int n=0;n<5;n++) {
               rect[i][n] = new Rectangle();

               st.resetSyntax();      // reset Syntax to read a number
               st.parseNumbers();
               st.whitespaceChars(0x0000, 0x0020);

               int type = st.nextToken(); // to read a number as the x1
               rect[i][n].x = (int)st.nval;
               type = st.nextToken(); // to read a number as the y1
               rect[i][n].y = (int)st.nval;

               type = st.nextToken(); // to read a number as the x2
               rect[i][n].width = (int)st.nval;
               type = st.nextToken(); // to read a number as the y2
               rect[i][n].height = (int)st.nval;
            }
            r.close();

            imageChoice.addItem(getParameter("imageDir["+i+"]"));
            hitTable[i] = false;

            images[i][0] = getImage(getDocumentBase(), path+"image1.jpg");
            images[i][1] = getImage(getDocumentBase(), path+"image0.jpg");

            tracker.addImage(images[i][0], i);
            tracker.addImage(images[i][1], i);
         } catch(MalformedURLException ex) {
            System.out.println(ex);
         } catch(IOException ex) {
            System.out.println(ex);
         }
      }
      lifeImage = getImage(getDocumentBase(), "images/life.jpg");
      tracker.addImage(lifeImage, 0);
      try {
         tracker.waitForAll();
      } catch(InterruptedException e) {
         System.out.println(e);
      }

      lifeBar.setImage(lifeImage);

      startStopButton.addMouseListener(new MouseAdapter() {
         public void mouseEntered(MouseEvent e) {
            e.getComponent().setForeground(Color.red);
         }
         public void mouseExited(MouseEvent e) {
            e.getComponent().setForeground(Color.black);
         }
      });

      startStopButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            clearGame();
            if(gameFlag == false) {
               initGame();

               startStopButton.setLabel("Stop");
               startGame();
               gameFlag = true;
            } else {
               startStopButton.setLabel("Start");
               stopGame();
               gameFlag = false;
            }
         }
      });

      MouseListener ml2 = new MouseAdapter() {
         public void mousePressed(MouseEvent e) {
            ImageCanvas p = (ImageCanvas)e.getSource();
            int x=e.getX();
            int y=e.getY();

            int index = p.correctArea(x, y);
            if((index >= 0)&&(p.isVirgin(index))) {
               p.disableVirgin(index);
               p.drawCorrect(x, y);
               congraturation();
            } else if(index == -1) {
               p.drawIncorrect(x, y);
               incorrect();
            }
         }
      };

      for(int i=0;i<PANEL_NUM;i++) {
         imageCanvas[i].addMouseListener(ml2);
         imageCanvas[i].setEnabled(false);
      }

      clearGame();
   }

   public void incorrect() {
      lifeBar.decLife(1);
      lifeBar.repaint();

      if(lifeBar.isDead()) {
         showAll();

         stopGame();

         WarningDialog dialog = new WarningDialog((Frame)this.getParent(), "Notice!",
                                                  "Game Over!!");
         dialog.setVisible(true);

         scoreBoard();
      }
   }

   public void congraturation() {
      if(++matchedNum >= ImageCanvas.MISMATCH_NUM) {
         stopGame();

         play(getDocumentBase(),"audio/gong.au");

         score += (100 * level + (TIMEOVER * 1000 - elapsedTime) / 100);
         scoreField.setText(""+score);

         WarningDialog dialog=null;
         if(levelUp() == false) {
            dialog = new WarningDialog((Frame)this.getParent(), "Notice!",
                                       "Congraturations!!");
            dialog.setVisible(true);

            scoreBoard();
         } else {
            startGame();
         }
      }
   }

   public void scoreBoard() {
      AppletContext appletContext = getAppletContext();
      String queryString = getDocumentBase().toString();
      int index = queryString.indexOf("HiddenCatch.jsp");
      if(index >= 0) {
         queryString = queryString.substring(0, index);
      }
      queryString += "ScoreBoard/ScoreBoard.jsp?score="+score;

      try {
         appletContext.showDocument(new URL(queryString), "_self");
      } catch(MalformedURLException ee) {
         appletContext.showStatus("URL Exception: " + ee);
      }
      clearGame();
   }

   public void timeover() {
      stopGame();
      showAll();
      stopGame();

      score += (100 * matchedNum + (TIMEOVER*1000 - elapsedTime) / 100);
      scoreField.setText(""+score);

      lifeBar.decLife(ImageCanvas.MISMATCH_NUM - matchedNum);
      lifeBar.repaint();

      WarningDialog dialog=null;
      if((levelUp() == false)||(lifeBar.isDead())) {
         dialog = new WarningDialog((Frame)this.getParent(), "Notice!",
                                    "Congraturations!!");
         dialog.setVisible(true);

         scoreBoard();
      } else {
         startGame();
      }
      imageChoice.select(selectedImage);
   }

   public void showAll() {
      imageCanvas[0].drawAll();
   }

   public boolean levelUp() {
      int i, n = imageChoice.getItemCount();

      try {
         Thread.sleep(1000);
      } catch (InterruptedException e) { }

      if((level+1) < n) {
         level++;

         boolean ff=true;
         for(int x=0;x<hitTable.length;x++) {
            ff = ff && hitTable[x];
         }
         if(ff) {
            return(false);
         }

         initGame();

         return(true);
      }
      return(false);
   }

   public void clearGame() {
      for(int i=0;i<hitTable.length;i++) {
         hitTable[i] = false;
      }

      level = 0;

      imageCanvas[0].setBack();
      imageCanvas[1].setBack();
   }

   public void initGame() {
      while(true) {
         int value = (int)(Math.random() * hitTable.length * 3) % hitTable.length;

         if(hitTable[value] == false) {
            hitTable[value] = true;
            selectedImage = value;

            break;
         }
      }

      matchedNum = 0;

      imageCanvas[0].setImage(images[selectedImage][0]);
      imageCanvas[1].setImage(images[selectedImage][1]);

      imageCanvas[0].setFront();
      imageCanvas[1].setFront();

      imageCanvas[0].setBounds(rect[selectedImage]);
   }

   public void startGame() {
      if(gameFlag == false) {
         gameFlag = true;

         imageCanvas[0].setFront();
         imageCanvas[1].setFront();

         imageCanvas[0].setEnabled(true);
         imageCanvas[1].setEnabled(false);

         progressiveBar.setTime(TIMEOVER);
         startTime = new Date().getTime();

         if(elapsedThread == null) {
            elapsedThread = new Thread(this);
         }
         elapsedThread.start();
      }
      startStopButton.setLabel("Stop");
      gameFlag = true;
   }

   public void stopGame() {
      elapsedThread = null;
      System.gc();

      if(gameFlag == true) {
         gameFlag = false;

         imageCanvas[0].setBack();
         imageCanvas[1].setBack();

         imageCanvas[0].setEnabled(false);
         imageCanvas[1].setEnabled(false);

         elapsedTimeLabel.setText("000");
         progressiveBar.setTime(0);
      }
      startStopButton.setLabel("Start");
   }

   public void stop() {
      stopGame();
   }

   public void run() {
      int time;

      while(true) {
         if(elapsedThread == null) {
            return;
         }

         if(gameFlag == true) {
            elapsedTime = new Date().getTime() - startTime;
            time = (int)(TIMEOVER - (int)(elapsedTime/1000));
   
            if(elapsedTimeLabel != null) {
               elapsedTimeLabel.setText(""+time);
            } else {
               elapsedTimeLabel.setText("000");
            }

            progressiveBar.setTime(time);

            if(time <= 0) {
               gameFlag = false;
               timeover();
               break;
            }
         }
         try {
            Thread.sleep(1000);
         } catch (InterruptedException e) { }
      }
      elapsedThread = null;
   }
}
