import java.awt.*;
import java.awt.event.*;

class LoadingBarWindow extends Dialog {
   Label messageLabel=null;
   TimeBar loadingBar=null;
   ImageCanvas logo=null;

   public LoadingBarWindow(Frame owner, Image logoImage, String message) {
      super(owner, "ٿε º", false);

      setLayout(new BorderLayout(4, 4));

      setBackground(Color.black);

      logo = new ImageCanvas(0, logoImage);
      logo.setSize(logoImage.getWidth(logo), logoImage.getHeight(logo));
      logo.setState(ImageCanvas.STATE_FRONT);

      Panel logoPanel = new Panel();
      logoPanel.add(logo);

      messageLabel = new Label(message);
      messageLabel.setBackground(Color.lightGray);

      loadingBar = new TimeBar(100);
      Panel barPanel = new Panel();
      barPanel.add(loadingBar);

      Panel statusPanel = new Panel(new BorderLayout(4, 4));
      statusPanel.add("North", messageLabel);
      statusPanel.add("Center", barPanel);

      add("Center", logoPanel);
      add("South", statusPanel);

      pack();

      setSize(getSize().width+16, getSize().height+8);

      autoAlign();

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });
   }

   public void setStatusLevel(int statusLevel) {
      loadingBar.setTime(statusLevel);
   }

   public void setMessage(String message) {
      messageLabel.setText(message);
   }

   public void setLogo(Image logoImage) {
      logo.setImage(logoImage);
   }

   public void autoAlign() {
      int w = Toolkit.getDefaultToolkit().getScreenSize().width;
      int h = Toolkit.getDefaultToolkit().getScreenSize().height;
      int x = (((w - getSize().width) / 2) < 0) ? 0 : ((w - getSize().width) / 2);
      int y = (((h - getSize().height) / 2) < 0) ? 0 : ((h - getSize().height) / 2);

      setLocation(x, y);
   }
}

