/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.io.*;
import java.net.*;
import java.sql.*;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.StringTokenizer;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

public class GClient extends Panel {
   final static int STEP_NONE        = 0;
   final static int STEP_PUT_PAE     = 1;
   final static int STEP_PUT_PAE_ING = 2;
   final static int STEP_SELECT_PAE  = 3;

   ClientLobby parentApplet=null;

   Vector myPaeList=null;             //   Ʈ
   Vector playerMePaeList=null;       //   Ʈ
   Vector player1PaeList=null;        //  1  Ʈ
   Vector player2PaeList=null;        //  2  Ʈ
   Vector badakPaeList=null;          // ٴ Ʈ
   Vector giriPaeList=null;           // ⸮() Ʈ

   Whatoo paes[]=null;
   String idString[]=null;
   int playerPoint[]=null, playerScore[]=null;
   int playerSsamCount[]=null, playerGoCount[]=null;
   boolean shakeFlag[]=null;

   Button joinButton=null, exitButton=null,standByButton = null;
   List displayBoard=null;
   TextArea boardChatArea=null;
   TextArea resultArea = null;
   TextField boardChatField=null;
   Panel pan=null, sidePan=null, sidePan1=null, sidePanBtn=null;

   MediaTracker godoriTrack=null;

   Image goImg=null;
   Image stopImg=null;
   Image bottomImg=null;
   Image backgroundImg=null;
   Image offImage=null;
   Graphics offGraphics=null;

   int currentStep=STEP_NONE;

   boolean myTurn=false, onSession=false, godie=false, gostop=false, firstTurn=false, myFirstTurn=false;
   int turnOwner=-1;

   public GClient(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
   }

   public void reset() {
      initGodori();
      repaint();
   }

   public void initGodori() {
      myPaeList.removeAllElements();            //   Ʈ
      player1PaeList.removeAllElements();       //  1  Ʈ
      player2PaeList.removeAllElements();       //  2  Ʈ
      playerMePaeList.removeAllElements();      //  2  Ʈ
      badakPaeList.removeAllElements();         // ٴ Ʈ
      giriPaeList.removeAllElements();          // ⸮() Ʈ

      playerScore[0] = 0;
      playerScore[1] = 0;
      playerScore[2] = 0;

      playerGoCount[0] = 0;
      playerGoCount[1] = 0;
      playerGoCount[2] = 0;

      playerSsamCount[0] = 0;
      playerSsamCount[1] = 0;
      playerSsamCount[2] = 0;

      shakeFlag[0] = false;
      shakeFlag[1] = false;
      shakeFlag[2] = false;

      playerPoint[0] = 0;
      playerPoint[1] = 0;
      playerPoint[2] = 0;

      turnOwner = -1;


   }

   public void initComponent() {
      boardChatArea.setText("");
      displayBoard.removeAll();
      boardChatField.setText("");
      resultArea.setText("");

      joinButton.setEnabled(false);
      exitButton.setEnabled(true);
   }

   public void init(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
   }

   public void init() {
      offImage = parentApplet.createImage(800, 584);
      offGraphics = offImage.getGraphics();

      myPaeList = new Vector();            //   Ʈ
      player1PaeList = new Vector();       //  1  Ʈ
      player2PaeList = new Vector();       //  2  Ʈ
      playerMePaeList = new Vector();      //  2  Ʈ
      badakPaeList = new Vector();         // ٴ Ʈ
      giriPaeList = new Vector();          // ⸮() Ʈ

      paes = new Whatoo[Whatoo.PAE_NUMBER];

      idString = new String[3];
      idString[0] = "";
      idString[1] = "";
      idString[2] = "";

      playerScore = new int[3];
      playerScore[0] = 0;
      playerScore[1] = 0;
      playerScore[2] = 0;

      playerGoCount = new int[3];
      playerGoCount[0] = 0;
      playerGoCount[1] = 0;
      playerGoCount[2] = 0;

      playerSsamCount = new int[3];
      playerSsamCount[0] = 0;
      playerSsamCount[1] = 0;
      playerSsamCount[2] = 0;

      playerPoint = new int[3];
      playerPoint[0] = 0;
      playerPoint[1] = 0;
      playerPoint[2] = 0;

      shakeFlag = new boolean[3];
      shakeFlag[0] = false;
      shakeFlag[1] = false;
      shakeFlag[2] = false;

//System.out.println("init : ۵Ǿϴ");

      Image frontNormalImage=null, frontRotateImage=null;

      godoriTrack = new MediaTracker(this);
      for(int i=0;i<Whatoo.PAE_NUMBER-1;i++) {
         frontNormalImage = parentApplet.getImage(parentApplet.getDocumentBase(),
                                            "images/go"+((i/4)+1)+"-"+((i%4)+1)+".gif");
         frontRotateImage = parentApplet.getImage(parentApplet.getDocumentBase(),
                                            "images/go"+((i/4)+1)+"-"+((i%4)+1)+"_1.gif");

         System.out.println("image : "+"images/go"+((i/4)+1)+"-"+((i%4)+1)+".gif");
         System.out.println("image : "+"images/go"+((i/4)+1)+"-"+((i%4)+1)+"_1.gif");

         godoriTrack.addImage(frontNormalImage, 0);
         godoriTrack.addImage(frontRotateImage, 0);

         paes[i] = new Whatoo(i, frontNormalImage, frontRotateImage, parentApplet);
         paes[i].setStatus(Whatoo.STATUS_FRONT_NORMAL);
      }
      frontNormalImage = parentApplet.getImage(parentApplet.getDocumentBase(),
                                            "images/GO0.GIF");
      frontRotateImage = parentApplet.getImage(parentApplet.getDocumentBase(),
                                            "images/GO0_1.GIF");

      System.out.println("image : "+"images/GO0.GIF");
      System.out.println("image : "+"images/GO0_1.GIF");

      godoriTrack.addImage(frontNormalImage, 0);
      godoriTrack.addImage(frontRotateImage, 0);

      paes[Whatoo.PAE_NUMBER-1] = new Whatoo(Whatoo.PAE_NUMBER-1,
                                             frontNormalImage,
                                              frontRotateImage, parentApplet);

      bottomImg = parentApplet.getImage(parentApplet.getDocumentBase(),
                                     "images/bottom.gif");
      backgroundImg = parentApplet.getImage(parentApplet.getDocumentBase(),
                                     "images/background.jpg");

      godoriTrack.addImage(bottomImg, 0);
      godoriTrack.addImage(backgroundImg, 0);
      try {
         godoriTrack.waitForAll();
      } catch(Exception e) {
      }

      Whatoo.setBackNormalImage(bottomImg);

      setLayout(null);
      setSize(800, 584);

      boardChatArea = new TextArea();
      boardChatArea.setBackground(new Color(254,249,209));
      boardChatArea.setForeground(Color.blue);
      boardChatArea.setBounds(612, 11, 183, 214);

      resultArea = new TextArea();
      resultArea.setBackground(new Color(31,119,0));
      resultArea.setForeground(new Color(255,255,255));
      resultArea.setFont(new Font("Batang",Font.PLAIN,12));
      resultArea.setBounds(180,12,273,103);

      displayBoard = new List();
      displayBoard.setBackground(new Color(254,249,209));
      displayBoard.setForeground(Color.blue);
      displayBoard.setBounds(612, 228, 183, 81);

      boardChatField = new TextField(20);
      boardChatField.setBackground(new Color(254,249,209));
      boardChatField.setForeground(Color.blue);
      boardChatField.setBounds(612, 313, 183, 23);

      joinButton = new Button("ϱ");
      joinButton.setBounds(610, 345, 60, 20);
      joinButton.setBackground(new Color(184,184,218));

      exitButton = new Button("");
      exitButton.setBounds(674, 345, 60, 20);
      exitButton.setBackground(new Color(184,184,218));

      standByButton = new Button("ʴ");
      standByButton.setBounds(738,345,60,20);
      standByButton.setBackground(new Color(184,184,218));

      add(displayBoard);
      add(boardChatArea);
      add(boardChatField);
      add(resultArea);

      add(joinButton);
      add(exitButton);
      add(standByButton);

      FocusListener wa = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            boardChatField.requestFocus();
         }
      };
      displayBoard.addFocusListener(wa);
      boardChatArea.addFocusListener(wa);
   }

   public void repaint() {
      paint(getGraphics());
   }

   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      int x=0, y=0, t = 0,p=0;
      Whatoo pae=null;
      Enumeration e=null;

      // draw background image
      offGraphics.drawImage(backgroundImg, 0, 0, this);

      // Whatoo area: (38 x 59)  -->  (40 x 60)

      // draw badak paes
      // Bounds: (179, 131) - (449, 352)
      //   Area: (270 x 221)
      // Pieces:   (5 x 3) + 80pts x 44pts
      //  HLINE: 16, 38, 12, 38, 12, 38, 12, 38, 12, 38, 16
      //  VLINE: 11, 59, 11, 59, 11, 59, 11
      int hCount=1, vCount=1;
      x = 179 + 16;
      y = 131 + 11;

      // ٴڿ  а  ̻ ִ üũ
      int paeCount[] = new int[13];  // Ŀ óϱ 
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      int xx=0, yy=0;
      int memorialPae[] = new int[4];  //  ̻ д 4  ̻ ȵ. ֳϸ
      for(int i=0;i<memorialPae.length;i++) {
         memorialPae[i] = -1;
      }
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);
         xx = pae.id / 4;
         if(++paeCount[xx] == 3) {
            memorialPae[yy++] = xx;    //  ̻ и Ѵ..
         }
      }

      // ٴ ߿  ¥ и  ׸...
      int xxx=0;
      for(int ii=0;ii<yy;ii++) {
         for(int i=0;i<badakPaeList.size();i++) {
            pae = (Whatoo)badakPaeList.elementAt(i);

            if(memorialPae[ii] == (pae.id/4)) {
               //  ٴа  ¥̸
               pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
               pae.draw(offGraphics, x+xxx, y);

               xxx += 16;
            }
         }
         hCount += 2;
         if(hCount < 4) {
            x += Whatoo.PAE_WIDTH + 12;
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // ٴ ߿ а ƴ  е ׸...
badakPaeList_XXXX:
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);

         for(int ii=0;ii<yy;ii++) {
            if(memorialPae[ii] == (pae.id/4)) {
               // ٴ ߿  ¥  ϳ̸,  ٴз Ѿ..
               continue badakPaeList_XXXX;
            }
         }
         pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
         pae.draw(offGraphics, x, y);
         // ٴ ߿  ¥  ϳ ƴϸ ׸..
         if(hCount++ < 5) {
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // draw giri pae
      if(giriPaeList.size() > 0) {
         pae = (Whatoo)giriPaeList.firstElement();
         pae.setStatus(Whatoo.STATUS_BACK_NORMAL);
         pae.draw(offGraphics, 179+16+Whatoo.PAE_WIDTH+12+Whatoo.PAE_WIDTH+12, 131+11+Whatoo.PAE_HEIGHT+11);
      }

      // draw my paes
      x = 482 + 3;
      y = 414 + 40;
      for(int i=0;i<myPaeList.size();i++) {
         pae = (Whatoo)myPaeList.elementAt(i);
         pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
         pae.draw(offGraphics, x, y);

         x += Whatoo.PAE_WIDTH + 3;
      }

      // draw player me paes
      x =  28 +  8;
      y = 425 + 5;
      // draw player me paes - Kwang
      e = playerMePaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isKwang(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
            pae.draw(offGraphics, x, y);

            x += 10;
         }
      }
      x += Whatoo.PAE_WIDTH;  // + 16;
      // draw player me paes - Five
      e = playerMePaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isFive(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
            pae.draw(offGraphics, x, y);

            x += 22;
         }
      }
      x += Whatoo.PAE_WIDTH;  // + 16;
      // draw player me paes - Ten
      e = playerMePaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isTen(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
            pae.draw(offGraphics, x, y);

            x += 22;
         }
      }
      x =  28 +  8;
      y += Whatoo.PAE_HEIGHT + 4;
      // draw player me paes - P
      e = playerMePaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isP(pae.id) || Whatoo.isDP(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_NORMAL);
            pae.draw(offGraphics, x, y);

            x += 20;
         }
      }

      // draw 2nd player paes
      x =  26 + 7 + Whatoo.PAE_HEIGHT + 8;
      y = 47 + 8;
      // draw 2nd player paes - Kwang
      e = player2PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isKwang(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 14;
         }
      }
      y += Whatoo.PAE_WIDTH - 2;
      // draw 2nd player paes - Five
      e = player2PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isFive(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y +=  22;
         }
      }
      y += Whatoo.PAE_WIDTH - 2;
      // draw 2nd player paes - Ten
      e = player2PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isTen(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 22;
         }
      }
      x =  26 + 7;
      y = 47 + 8;
      // draw 2nd player paes - P
      e = player2PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isP(pae.id) || Whatoo.isDP(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 20;
         }
      }

      // draw 1st player paes
      x = 463 + 7 + Whatoo.PAE_HEIGHT + 8;
      y = 47 + 8;
      // draw 1st player paes - Kwang
      e = player1PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isKwang(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 14;
         }
      }
      y += Whatoo.PAE_WIDTH - 2;
      // draw 1st player paes - Five
      e = player1PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isFive(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 22;
         }
      }
      y += Whatoo.PAE_WIDTH - 2;
      // draw 1st player paes - Ten
      e = player1PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isTen(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 22;
         }
      }
      x = 463 + 7;
      y = 47 + 8;
      // draw 1st player paes - P
      e = player1PaeList.elements();
      while(e.hasMoreElements()) {
         pae = (Whatoo)e.nextElement();
         if(Whatoo.isP(pae.id) || Whatoo.isDP(pae.id)) {
            pae.setStatus(Whatoo.STATUS_FRONT_ROTATE);
            pae.draw(offGraphics, x, y);

            y += 20;
         }
      }
      offGraphics.setColor(Color.white);
      offGraphics.drawString("ID: "+idString[0], 70,407);
      offGraphics.drawString("ID: "+idString[1], 510,24);
      offGraphics.drawString("ID: "+idString[2], 65,24);

      offGraphics.drawString("/հ:"+playerScore[0]+"/"+playerPoint[0], 70,424 );
      offGraphics.drawString("/հ:"+playerScore[1]+"/"+playerPoint[1], 510, 41);
      offGraphics.drawString("/հ:"+playerScore[2]+"/"+playerPoint[2], 65, 41);

      offGraphics.setColor(Color.red);
      if(turnOwner == 0) {
         offGraphics.fillRect(747, 414, 20, 20);
      } else if(turnOwner == 1) {
         offGraphics.fillRect(588, 345, 20, 20);
      } else if(turnOwner == 2) {
         offGraphics.fillRect(134, 345, 20, 20);
      }
      g.drawImage(offImage, 0, 0, this);
   }

   public synchronized boolean action(Event event, Object arg) {
      String message = null;
      if(event.target == exitButton) {
         message = "504|"+parentApplet.playerId+"|*|exit";   //  ˸
         sendToServer(message);

         // Switching Layout Screen (Godori Screen to Lobby Screen)
         parentApplet.makeButton.setEnabled(true);
         parentApplet.joinButton.setEnabled(false);
         parentApplet.exitButton.setEnabled(true);

         parentApplet.godoriCardLayout.show(parentApplet.cardPanel, "Lobbypanel");
         parentApplet.currentRoomIsLobby = true;

         message = "352|"+parentApplet.playerId;  // 渮Ʈ û
         sendToServer(message);

         initGodori();
         initComponent();
      } else if(event.target == joinButton) {
         boolean available=true;
         if(available == true) {
            message = "502|"+parentApplet.playerId+"|*|join";   //  ϱ
            sendToServer(message);
            joinButton.setEnabled(false);
         }
      } else if(event.target == boardChatField) {
         message = "500|"+parentApplet.playerId+"|*|"+boardChatField.getText();

         sendToServer(message);
         boardChatField.setText("");
      } else if(event.target == standByButton) {
         message = "584|"+parentApplet.playerId;

         sendToServer(message);
      }

      return true;
   }

   public void blinkingRect(Graphics g, Whatoo whatoo, int x, int y, int width, int height, int border, int count, int period, Color color) {
      g.setColor(color);
      for(int c=0;c<count;c++) {
         for(int b=0;b<border;b++) {
            g.drawRect(x+b, y+b, width-b*2-1, height-b*2-1);
         }
         try {
            Thread.sleep(period);
         } catch(Exception e) {
         }
         whatoo.draw(g, x, y);
         try {
            Thread.sleep(period);
         } catch(Exception e) {
         }
      }
   }

   public void animatePut(Whatoo whatoo, int x, int y, int c) {
      Graphics g = getGraphics();

      whatoo.setStatus(whatoo.STATUS_FRONT_NORMAL);
      whatoo.draw(g, x, y);

      if(whatoo.isFrontRotate() || whatoo.isBackRotate()) {
         blinkingRect(g, whatoo,
                      x,                  // x
                      y,                  // y
                      Whatoo.PAE_HEIGHT,  // width
                      Whatoo.PAE_WIDTH,  // height
                      4,                  // Thickness
                      c,                  // Count
                      100,                // Blinking Period
                      Color.blue);        // Blinking Color
      } else {
         blinkingRect(g, whatoo,
                      x,                  // x
                      y,                  // y
                      Whatoo.PAE_WIDTH,   // width
                      Whatoo.PAE_HEIGHT,  // height
                      4,                  // Thickness
                      c,                  // Count
                      100,                // Blinking Period
                      Color.blue);        // Blinking Color
      }
   }

   public int getBadakX(Whatoo whatoo) {
      int x=0, y=0;
      int hCount=1, vCount=1;
      Whatoo pae=null;

      // Whatoo area: (38 x 59)  -->  (40 x 60)

      // draw badak paes
      // Bounds: (179, 131) - (449, 352)
      //   Area: (270 x 221)
      // Pieces:   (5 x 3) + 80pts x 44pts
      //  HLINE: 16, 38, 12, 38, 12, 38, 12, 38, 12, 38, 16
      //  VLINE: 11, 59, 11, 59, 11, 59, 11
      x = 179 + 16;
      y = 131 + 11;

      // ٴڿ  а  ִ üũ
      int paeCount[] = new int[13];  // Ŀ óϱ 
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      int xx=0, yy=0;
      int memorialPae[] = new int[4];  // ¥ д 4  ̻ ȵ. ֳϸ
      for(int i=0;i<memorialPae.length;i++) {
         memorialPae[i] = -1;
      }
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);
         xx = pae.id / 4;
         if(++paeCount[xx] >= 3) {
            memorialPae[yy++] = xx;    //  ̻ и Ѵ..
         }
      }

      // ٴ ߿  ¥ΰ üũ
      for(int ii=0;ii<yy;ii++) {
         for(int i=0;i<badakPaeList.size();i++) {
            pae = (Whatoo)badakPaeList.elementAt(i);

            if(memorialPae[ii] == (pae.id/4)) {
               //  ٴа  ¥̸
               if((pae.id/4) == (whatoo.id/4)) {
                  return(x+16+8);
               }
            }
         }
         hCount += 2;
         if(hCount < 4) {
            x += Whatoo.PAE_WIDTH + 12;
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // ٴ ߿ а ƴ  е ׸...
badakPaeList_XXXX:
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);

         for(int ii=0;ii<yy;ii++) {
            if(memorialPae[ii] == (pae.id/4)) {
               // ٴ ߿  ¥  ϳ̸,  ٴз Ѿ..
               continue badakPaeList_XXXX;
            }
         }

         //  ٴа , װɷ  Ѵ...
         if(pae.id == whatoo.id) {
            return(x+8);
         }
         // ٴ ߿  ¥  ϳ ƴϸ ׸..
         if(hCount++ < 5) {
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // ٴп  ٸ(Ʈ ġ) ģ...
      return(395);
   }

   public int getBadakY(Whatoo whatoo) {
      int x=0, y=0;
      int hCount=1, vCount=1;
      Whatoo pae=null;

      // Whatoo area: (38 x 59)  -->  (40 x 60)

      // draw badak paes
      // Bounds: (179, 131) - (449, 352)
      //   Area: (270 x 221)
      // Pieces:   (5 x 3) + 80pts x 44pts
      //  HLINE: 16, 38, 12, 38, 12, 38, 12, 38, 12, 38, 16
      //  VLINE: 11, 59, 11, 59, 11, 59, 11
      x = 179 + 16;
      y = 131 + 11;

      // ٴڿ  а  ִ üũ
      int paeCount[] = new int[13];  // Ŀ óϱ 
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      int xx=0, yy=0;
      int memorialPae[] = new int[4];  // ¥ д 4  ̻ ȵ. ֳϸ
      for(int i=0;i<memorialPae.length;i++) {
         memorialPae[i] = -1;
      }
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);
         xx = pae.id / 4;
         if(++paeCount[xx] >= 3) {
            memorialPae[yy++] = xx;    //  ̻ и Ѵ..
         }
      }

      // ٴ ߿  ¥ΰ üũ
      for(int ii=0;ii<yy;ii++) {
         for(int i=0;i<badakPaeList.size();i++) {
            pae = (Whatoo)badakPaeList.elementAt(i);

            if(memorialPae[ii] == (pae.id/4)) {
               //  ٴа  ¥̸
               if((pae.id/4) == (whatoo.id/4)) {
                  return(y+8);
               }
            }
         }
         hCount += 2;
         if(hCount < 4) {
            x += Whatoo.PAE_WIDTH + 12;
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // ٴ ߿ а ƴ  е ׸...
badakPaeList_XXXX:
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);

         for(int ii=0;ii<yy;ii++) {
            if(memorialPae[ii] == (pae.id/4)) {
               // ٴ ߿  ¥  ϳ̸,  ٴз Ѿ..
               continue badakPaeList_XXXX;
            }
         }

         //  ٴа , װɷ  Ѵ...
         if(pae.id == whatoo.id) {
            return(y+8);
         }
         // ٴ ߿  ¥  ϳ ƴϸ ׸..
         if(hCount++ < 5) {
            x += Whatoo.PAE_WIDTH + 12;
         } else {
            vCount++;
            hCount = 1;
            x  = 179 + 16;
            y += Whatoo.PAE_HEIGHT + 11;
         }
         if((vCount == 2)&&(hCount == 3)) {   // Skip for Kiri Pae Area
            hCount++;
            x += Whatoo.PAE_WIDTH + 12;
         }
      }

      // ٴп  ٸ(Ʈ ġ) ģ...
      return(282);
   }

   public Whatoo getP(Vector paeList) {
      Whatoo pae=null;

      for(int i=0;i<paeList.size();i++) {
         pae = (Whatoo)paeList.elementAt(i);
         if(Whatoo.isP(pae.id)) {
            return(pae);
         }
      }
      for(int i=0;i<paeList.size();i++) {
         pae = (Whatoo)paeList.elementAt(i);
         if(Whatoo.isDP(pae.id)) {
            return(pae);
         }
      }
      return(null);
   }

   public void jokerInBadak(int who) {
      Whatoo whatoo=null, giriWhatoo=null;
      Enumeration e=null;

      // ٴп Ŀ ִ ׽Ʈ
      e = badakPaeList.elements();
      while(e.hasMoreElements()) {
         whatoo = (Whatoo)e.nextElement();
         if(whatoo.id == Whatoo.WHATOO_J0) {   // ٴп Ŀ 
            // Ŀ ٴп  з ̵
            doExchangePae("$$ٴ$$", idString[who], whatoo.id);

            // ⸮п Ŀ  ٴи   ..
            giriWhatoo = (Whatoo)giriPaeList.firstElement();
            doExchangePae("$$⸮$$", "$$ٴ$$", giriWhatoo.id);
         }
      }

      // ٴп   ¥ ִ ˻Ͽ,  ڽ() ´....
      int paeCount[] = new int[13]; // Ŀ ֱ  13 п  īͰ ʿ
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      int xx=0, yy=0;
      int memorialPae[] = new int[4];  // ¥ д 4  ̻ ȵ 
      for(int i=0;i<memorialPae.length;i++) {
         memorialPae[i] = -1;
      }
      e = badakPaeList.elements();
      while(e.hasMoreElements()) {
         whatoo = (Whatoo)e.nextElement();
         xx = whatoo.id / 4;
         if(++paeCount[xx] == 4) {
            memorialPae[yy++] = xx;    //  ̻ и Ѵ..
         }
      }

      int xxx=0;
      for(int ii=0;ii<yy;ii++) {
         e = badakPaeList.elements();
         while(e.hasMoreElements()) {
            whatoo = (Whatoo)e.nextElement();
            if(memorialPae[ii] == (whatoo.id/4)) {
               // ٴ ߿ ¥ а  ڽ() ´.
               doExchangePae("$$ٴ$$", idString[who], whatoo.id);
            }
         }
      }
   }

   public void shakeCheck() {
      Whatoo whatoo=null;

      int paeCount[] = new int[13];
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      //  а ֳ üũ
      for(int i=0;i<myPaeList.size();i++) {
         whatoo = (Whatoo)myPaeList.elementAt(i);
         paeCount[whatoo.id/4]++;
         if(paeCount[whatoo.id/4] >= 3) {
            String message = "560|"+idString[0]+"|DOUBLE||"+((whatoo.id/4)+1);
            sendToServer(message);

            return;
         }
      }
   }

   public void chongTongCheck() {
      Whatoo whatoo=null;

      int paeCount[] = new int[13];
      for(int i=0;i<paeCount.length;i++) {
         paeCount[i] = 0;
      }
      //  а ֳ üũ
      for(int i=0;i<myPaeList.size();i++) {
         whatoo = (Whatoo)myPaeList.elementAt(i);
         paeCount[whatoo.id/4]++;
         if(paeCount[whatoo.id/4] >= 4) {
            String message = "560|"+idString[0]+"|ONSTOP"+"|"+"CHONGTONG";
            sendToServer(message);

            doChongTong((whatoo.id/4)+1);  //  Ͽ ޽  DB UPDATE
         }
      }
   }

   void doAnimatePut(int putPae, int x, int y, int c) {
      String message = "560|"+parentApplet.playerId+"|ANIMATEPUT|"+putPae+","+x+","+y+","+c;

      sendToServer(message);
   }

   void applyAnimatePut(int putPae, int x, int y, int c) {
      animatePut(paes[putPae], x, y, c);
   }

   // doPut - Ŭ̾Ʈ/   (GClient/GRoom  )
   boolean doPut(int putPae) {
      //int p1 = mypae[p] / 4;
      int badakExist=0, badakExist2=0;
      Whatoo badakSelect=null, badakSelect2=null;
      Whatoo badakWhatooX1[] = new Whatoo[4], badakWhatooX2[] = new Whatoo[4];

      Vector tempPlayerMePaeList = new Vector();		//    ̸ üũҶ
      Vector tempBadakPaeList = new Vector();			// Ͼ üũҶ
      for(int i=0;i<playerMePaeList.size();i++) {
         tempPlayerMePaeList.addElement(playerMePaeList.elementAt(i));
      }
      for(int i=0;i<badakPaeList.size();i++) {
         tempBadakPaeList.addElement(badakPaeList.elementAt(i));
      }

      Whatoo putWhatoo=null, giriWhatoo=null, giriWhatoo2=null;

//      Graphics g = getGraphics();
      putWhatoo = (Whatoo)myPaeList.elementAt(putPae);

      putWhatoo.setStatus(Whatoo.STATUS_FRONT_NORMAL);
      animatePut(putWhatoo,
                 482 + 3 + putPae * (Whatoo.PAE_WIDTH + 3),    // x
                 414 + 40, 1);
/*
      doAnimatePut(putWhatoo.id,
                 482 + 3 + putPae * (Whatoo.PAE_WIDTH + 3),    // x
                 414 + 40, 2);
*/
      // ģ а Ŀ  ó...
      if(putWhatoo.id == Whatoo.WHATOO_J0) {
         // Ŀ  , п ִ Ŀ  з  
         // Ŭ̾Ʈ ٷ óϰ,
         // ٸ 鿡Դ   п Ŀ ٷ ߰ϵ .
         myPaeList.removeElement(putWhatoo);
//         playerMePaeList.addElement(putWhatoo);
         tempPlayerMePaeList.addElement(putWhatoo);  //    и ӽ÷ óϿ,
                                                     //   ϱ ؼ
                                                     // ׷  ,     尡 ޱ 
                                                     //  ó  ȣ.

         doExchangePae("$$$$", idString[0], putWhatoo.id);

         giriWhatoo = (Whatoo)giriPaeList.firstElement();

         // Ŀ  , ⸮п  з    
         // Ŭ̾Ʈ ٷ óϰ,
         // ٸ 鿡Դ ⸮ п  ֵ .
//         giriPaeList.removeElement(giriWhatoo);
         myPaeList.addElement(giriWhatoo);
         doExchangePae("$$⸮$$", "$$$$", giriWhatoo.id);

         // paint(getGraphics());
         repaint();

         return false;
      }

      // ģ а Ŀ ƴ  ó...

      for(int i=0;i<badakPaeList.size();i++) {
         Whatoo whatoo = (Whatoo)badakPaeList.elementAt(i);
         if((whatoo.id / 4) == (putWhatoo.id / 4)) {
            badakWhatooX1[badakExist] = whatoo;
            badakExist++;
         }
      }

      // ġ  óϱ
      int x=0;
      int y=0;
      if(badakExist == 0) {
         x = 395;
         y = 282;
      } else if(badakExist == 1) {
         x = getBadakX(badakWhatooX1[0]);
         y = getBadakY(badakWhatooX1[0]);
         badakSelect = badakWhatooX1[0];
      } else if(badakExist == 2) {
         Whatoo badakWhatoo1 = badakWhatooX1[0];
         Whatoo badakWhatoo2 = badakWhatooX1[1];

         SelectImageDialog s = new SelectImageDialog(parentApplet.baseFrame,
                                                " ",
                                                badakWhatoo1.frontNormalImage ,
                                                badakWhatoo2.frontNormalImage);
         s.show();
         if(s.state == SelectImageDialog.STATE_1) {
            badakSelect = badakWhatooX1[0];
         } else {
            badakSelect = badakWhatooX1[1];
         }

         x = getBadakX(badakSelect);
         y = getBadakY(badakSelect);
      } else if(badakExist == 3) {
         x = getBadakX(badakWhatooX1[0]);
         y = getBadakY(badakWhatooX1[0]);
      }
      putWhatoo.setStatus(Whatoo.STATUS_FRONT_NORMAL);

      doSound("STRIKE");

      animatePut(putWhatoo, x, y, 1);
      doAnimatePut(putWhatoo.id, x, y, 1);

      try {
         Thread.sleep(500);
      } catch(Exception e) {
      }

      //   óϱ
      boolean joker=false;
      giriWhatoo = (Whatoo)giriPaeList.firstElement();
      //  а Ŀ̸...
      if(giriWhatoo.id == Whatoo.WHATOO_J0) {
         giriWhatoo.setStatus(Whatoo.STATUS_FRONT_NORMAL);

         doSound("STRIKE");
         animatePut(giriWhatoo, 395, 282, 1);
         doAnimatePut(giriWhatoo.id, 395, 282, 1);

         // ⸮п а Ŀ̸,
         // Ʒ κп Ŀп Ŀ   и ó
         giriPaeList.removeElement(giriWhatoo);
         tempBadakPaeList.addElement(giriWhatoo);		// Ͼ 
         doExchangePae("$$⸮$$", "$$ٴ$$", giriWhatoo.id);

         giriWhatoo = (Whatoo)giriPaeList.firstElement();
         giriWhatoo.setStatus(Whatoo.STATUS_FRONT_NORMAL);

         doSound("STRIKE");

         animatePut(giriWhatoo, 395, 282, 1);
         doAnimatePut(giriWhatoo.id, 395, 282, 1);
      }
      for(int i=0;i<badakPaeList.size();i++) {
         Whatoo whatoo = (Whatoo)badakPaeList.elementAt(i);
         if((whatoo.id / 4) == (giriWhatoo.id / 4)) {
            badakWhatooX2[badakExist2] = whatoo;
            badakExist2++;
         }
      }

      if(badakExist2 == 0) {
         x = 395 - (Whatoo.PAE_WIDTH + 2);
         y = 282;
      } else if(badakExist2 == 1) {
         x = getBadakX(badakWhatooX2[0]);
         y = getBadakY(badakWhatooX2[0]);
         badakSelect2 = badakWhatooX2[0];
      } else if(badakExist2 == 2) {
         if((putWhatoo.id/4) == (giriWhatoo.id/4)) {
            if(badakSelect.id == badakWhatooX2[0].id) {
               badakSelect2 = badakWhatooX2[1];
            } else {
               badakSelect2 = badakWhatooX2[0];
            }
         } else {
            Whatoo badakWhatoo1 = badakWhatooX2[0];
            Whatoo badakWhatoo2 = badakWhatooX2[1];

            SelectImageDialog s = new SelectImageDialog(parentApplet.baseFrame,
                                                   " ",
                                                   badakWhatoo1.frontNormalImage ,
                                                   badakWhatoo2.frontNormalImage);
            s.show();
            if(s.state == SelectImageDialog.STATE_1) {
               badakSelect2 = badakWhatooX2[0];
            } else {
               badakSelect2 = badakWhatooX2[1];
            }
         }
         x = getBadakX(badakSelect2);
         y = getBadakY(badakSelect2);
      } else if(badakExist2 == 3) {
         x = getBadakX(badakWhatooX2[0]);
         y = getBadakY(badakWhatooX2[0]);
      }
      giriWhatoo.setStatus(Whatoo.STATUS_FRONT_NORMAL);

      doSound("STRIKE");

      animatePut(giriWhatoo, x, y, 1);
      doAnimatePut(giriWhatoo.id, x, y, 1);

      try {
         Thread.sleep(500);
      } catch(Exception e) {
      }

      boolean ssam=false;
      //  п ٴ и ġ   ó,   óϱ...
      if((putWhatoo.id/4) == (giriWhatoo.id/4)) {
         if(badakExist == 1) {
            // ģ п  а ٴڿ    - "մ" ó
            myPaeList.removeElement(putWhatoo);
//               playerMePaeList.addElement(putWhatoo);
            if(myPaeList.size() > 0) {   //   ƴ  "մ" ó
//                  badakPaeList.addElement(putWhatoo);
               tempBadakPaeList.addElement(putWhatoo);		// Ͼ 
               doExchangePae("$$$$", "$$ٴ$$", putWhatoo.id);

//                  giriPaeList.removeElement(giriWhatoo);
//                  badakPaeList.addElement(giriWhatoo);
               tempBadakPaeList.addElement(giriWhatoo);		// Ͼ 
               doExchangePae("$$⸮$$", "$$ٴ$$", giriWhatoo.id);

               if(myFirstTurn == true) {
                  doFirstSsam((putWhatoo.id/4)+1);
               }
               ssam = true;
               doSsam((putWhatoo.id/4)+1);
            } else {                      //    ׳  ɷ ó
               tempPlayerMePaeList.addElement(putWhatoo);
               //    и ӽ÷ óϿ,
               //   ϱ ؼ
               // ׷  ,     尡 ޱ 
               //  ó  ȣ.
               doExchangePae("$$$$", idString[0], putWhatoo.id);

      //            giriPaeList.removeElement(giriWhatoo);
      //            badakPaeList.addElement(giriWhatoo);
               tempBadakPaeList.addElement(giriWhatoo);		// Ͼ 
               doExchangePae("$$⸮$$", "$$ٴ$$", giriWhatoo.id);

               Whatoo badakWhatoo = badakSelect;
   //            badakPaeList.removeElement(badakWhatoo);
   //            playerMePaeList.addElement(badakWhatoo);
               tempPlayerMePaeList.addElement(badakWhatoo);
               //    и ӽ÷ óϿ,
               //   ϱ ؼ
               // ׷  ,     尡 ޱ 
               //  ó  ȣ.
               tempBadakPaeList.removeElement(badakWhatoo);	// Ͼ 
               doExchangePae("$$ٴ$$", idString[0], badakWhatoo.id);
            }
         } else if(badakExist == 2) {
            // 2. ģ п  а ٴڿ    - "" ó
            myPaeList.removeElement(putWhatoo);
//            playerMePaeList.addElement(putWhatoo);
            tempPlayerMePaeList.addElement(putWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$$$", idString[0], putWhatoo.id);

            Whatoo badakWhatoo = badakSelect;
//            badakPaeList.removeElement(badakWhatoo);
//            playerMePaeList.addElement(badakWhatoo);
            tempPlayerMePaeList.addElement(badakWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            tempBadakPaeList.removeElement(badakWhatoo);	// Ͼ 
            doExchangePae("$$ٴ$$", idString[0], badakWhatoo.id);

//            giriPaeList.removeElement(giriWhatoo);
//            playerMePaeList.addElement(giriWhatoo);
            tempPlayerMePaeList.addElement(giriWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$⸮$$", idString[0], giriWhatoo.id);

            Whatoo badakWhatoo2 = badakSelect2;
//            badakPaeList.removeElement(badakWhatoo2);
//            playerMePaeList.addElement(badakWhatoo2);
            tempPlayerMePaeList.addElement(badakWhatoo2);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            tempBadakPaeList.removeElement(badakWhatoo2);	// Ͼ 
            doExchangePae("$$ٴ$$", idString[0], badakWhatoo2.id);

            if(myPaeList.size() > 0) {    //  ƴ 쿡 徿 ´..
               // κ  徿    óϱ
               Whatoo p1Whatoo = getP(player1PaeList);
               if(p1Whatoo != null) {
   //               player1PaeList.removeElement(p1Whatoo);
   //               playerMePaeList.addElement(p1Whatoo);
                  tempPlayerMePaeList.addElement(p1Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[1], idString[0], p1Whatoo.id);
                  doSound("drip");
               }

               Whatoo p2Whatoo = getP(player2PaeList);
               if(p2Whatoo != null) {
   //               player2PaeList.removeElement(p2Whatoo);
   //               playerMePaeList.addElement(p2Whatoo);
                  tempPlayerMePaeList.addElement(p2Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[2], idString[0], p2Whatoo.id);
                  doSound("drip");

               }
            }
         } else {
            // ģ п  д  
            //    - "" ó, κ 徿 ´..
            myPaeList.removeElement(putWhatoo);
//            playerMePaeList.addElement(putWhatoo);
            tempPlayerMePaeList.addElement(putWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$$$", idString[0], putWhatoo.id);

//            giriPaeList.removeElement(giriWhatoo);
//            playerMePaeList.addElement(giriWhatoo);
            tempPlayerMePaeList.addElement(giriWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$⸮$$", idString[0], giriWhatoo.id);

            if(myPaeList.size() > 0) {    //  ƴ 쿡 徿 ´..
               // κ  徿    óϱ
               Whatoo p1Whatoo = getP(player1PaeList);
               if(p1Whatoo != null) {
   //               player1PaeList.removeElement(p1Whatoo);
   //               playerMePaeList.addElement(p1Whatoo);
                  tempPlayerMePaeList.addElement(p1Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[1], idString[0], p1Whatoo.id);
                  doSound("drip");
               }

               Whatoo p2Whatoo = getP(player2PaeList);
               if(p2Whatoo != null) {
   //               player2PaeList.removeElement(p2Whatoo);
   //               playerMePaeList.addElement(p2Whatoo);
                  tempPlayerMePaeList.addElement(p2Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[2], idString[0], p2Whatoo.id);
                  doSound("drip");
               }
            }
         }
      } else {
         // ģ п  ó
         if(badakExist == 0) {
            // ģ п  а ٴڿ  
            myPaeList.removeElement(putWhatoo);
//            badakPaeList.addElement(putWhatoo);
            tempBadakPaeList.addElement(putWhatoo);	// Ͼ 
            doExchangePae("$$$$", "$$ٴ$$", putWhatoo.id);
         } else if((badakExist == 1)||(badakExist == 2)) {
            // ģ п  а ٴڿ /   
            Whatoo badakWhatoo = badakSelect;
//            badakPaeList.removeElement(badakWhatoo);
//            playerMePaeList.addElement(badakWhatoo);
            tempPlayerMePaeList.addElement(badakWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            tempBadakPaeList.removeElement(badakWhatoo);	// Ͼ 
            doExchangePae("$$ٴ$$", idString[0], badakWhatoo.id);

            myPaeList.removeElement(putWhatoo);
//            playerMePaeList.addElement(putWhatoo);
            tempPlayerMePaeList.addElement(putWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$$$", idString[0], putWhatoo.id);
         } else if(badakExist == 3) {
            // ģ п  а ٴڿ    - ģ з ""  
            for(int i=0;i<3;i++) {
               Whatoo badakWhatoo = badakWhatooX1[i];
//               badakPaeList.removeElement(badakWhatoo);
//               playerMePaeList.addElement(badakWhatoo);
               tempPlayerMePaeList.addElement(badakWhatoo);
               //    и ӽ÷ óϿ,
               //   ϱ ؼ
               // ׷  ,     尡 ޱ 
               //  ó  ȣ.
               tempBadakPaeList.removeElement(badakWhatoo);	 // Ͼ 
               doExchangePae("$$ٴ$$", idString[0], badakWhatoo.id);
            }
            myPaeList.removeElement(putWhatoo);
//            playerMePaeList.addElement(putWhatoo);
            tempPlayerMePaeList.addElement(putWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$$$", idString[0], putWhatoo.id);

            if(myPaeList.size() > 0) {    //  ƴ 쿡 徿 ´..
               // κ  徿    óϱ
               Whatoo p1Whatoo = getP(player1PaeList);
               if(p1Whatoo != null) {
   //               player1PaeList.removeElement(p1Whatoo);
   //               playerMePaeList.addElement(p1Whatoo);
                  tempPlayerMePaeList.addElement(p1Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[1], idString[0], p1Whatoo.id);
                  doSound("drip");
               }

               Whatoo p2Whatoo = getP(player2PaeList);
               if(p2Whatoo != null) {
   //               player2PaeList.removeElement(p2Whatoo);
   //               playerMePaeList.addElement(p2Whatoo);
                  tempPlayerMePaeList.addElement(p2Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[2], idString[0], p2Whatoo.id);
                  doSound("drip");
               }
            }
         }
         //  п  ó
         if(badakExist2 == 0) {
            //  п  а ٴڿ  
//            giriPaeList.removeElement(giriWhatoo);
//            badakPaeList.addElement(giriWhatoo);
            tempBadakPaeList.addElement(giriWhatoo);	 // Ͼ 
            doExchangePae("$$⸮$$", "$$ٴ$$", giriWhatoo.id);
         } else if((badakExist2 == 1)||(badakExist2 == 2)) {
            //  п  а ٴڿ /   
            Whatoo badakWhatoo2 = badakSelect2;
//            badakPaeList.removeElement(badakWhatoo2);
//            playerMePaeList.addElement(badakWhatoo2);
            tempPlayerMePaeList.addElement(badakWhatoo2);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            tempBadakPaeList.removeElement(badakWhatoo2); // Ͼ 
            doExchangePae("$$ٴ$$", idString[0], badakWhatoo2.id);

//            giriPaeList.removeElement(giriWhatoo);
//            playerMePaeList.addElement(giriWhatoo);
            tempPlayerMePaeList.addElement(giriWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$⸮$$", idString[0], giriWhatoo.id);
         } else if(badakExist2 == 3) {
            //  п  а ٴڿ    - ""  
            for(int i=0;i<3;i++) {
               Whatoo badakWhatoo2 = badakWhatooX2[i];
//               badakPaeList.removeElement(badakWhatoo2);
//               playerMePaeList.addElement(badakWhatoo2);
               tempPlayerMePaeList.addElement(badakWhatoo2);
               //    и ӽ÷ óϿ,
               //   ϱ ؼ
               // ׷  ,     尡 ޱ 
               //  ó  ȣ.
               tempBadakPaeList.removeElement(badakWhatoo2); // Ͼ 
               doExchangePae("$$ٴ$$", idString[0], badakWhatoo2.id);
            }
//            giriPaeList.removeElement(giriWhatoo);
//            playerMePaeList.addElement(giriWhatoo);
            tempPlayerMePaeList.addElement(giriWhatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae("$$⸮$$", idString[0], giriWhatoo.id);

            if(myPaeList.size() > 0) {
               //  ƴ 쿡 徿 ´..
               // κ  徿    óϱ
               Whatoo p1Whatoo = getP(player1PaeList);
               if(p1Whatoo != null) {
   //               player1PaeList.removeElement(p1Whatoo);
   //               playerMePaeList.addElement(p1Whatoo);
                  tempPlayerMePaeList.addElement(p1Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[1], idString[0], p1Whatoo.id);
                  doSound("drip");
               }

               Whatoo p2Whatoo = getP(player2PaeList);
               if(p2Whatoo != null) {
   //               player2PaeList.removeElement(p2Whatoo);
   //               playerMePaeList.addElement(p2Whatoo);
                  tempPlayerMePaeList.addElement(p2Whatoo);
                  //    и ӽ÷ óϿ,
                  //   ϱ ؼ
                  // ׷  ,     尡 ޱ 
                  //  ó  ȣ.
                  doExchangePae(idString[2], idString[0], p2Whatoo.id);
                  doSound("drip");
               }
            }
         }
      }

	  // а Ŀ  ó
      if(joker == true) {
         doExchangePae("$$$$", idString[0], Whatoo.WHATOO_J0);
      }

      //  ʰ Ȥö ٴп Ŀ  ´...
      if(!ssam && badakPaeList.contains(paes[Whatoo.WHATOO_J0])) {
//         badakPaeList.removeElement(paes[Whatoo.WHATOO_J0]);
//         playerMePaeList.addElement(paes[Whatoo.WHATOO_J0]);
         tempPlayerMePaeList.addElement(paes[Whatoo.WHATOO_J0]);
         //    и ӽ÷ óϿ,
         //   ϱ ؼ
         // ׷  ,     尡 ޱ 
         //  ó  ȣ.
         tempBadakPaeList.removeElement(paes[Whatoo.WHATOO_J0]);
         doExchangePae("$$ٴ$$", idString[0], Whatoo.WHATOO_J0);
      }

      //  ó
      if((myPaeList.size() > 0)&&    //  ƴ 쿡 徿 ´..
         (tempBadakPaeList.size() == 0)) {
         // κ  徿    óϱ
         Whatoo p1Whatoo = getP(player1PaeList);
         if(p1Whatoo != null) {
//               player1PaeList.removeElement(p1Whatoo);
//               playerMePaeList.addElement(p1Whatoo);
            tempPlayerMePaeList.addElement(p1Whatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae(idString[1], idString[0], p1Whatoo.id);
            doSound("drip");
         }

         Whatoo p2Whatoo = getP(player2PaeList);
         if(p2Whatoo != null) {
//               player2PaeList.removeElement(p2Whatoo);
//               playerMePaeList.addElement(p2Whatoo);
            tempPlayerMePaeList.addElement(p2Whatoo);
            //    и ӽ÷ óϿ,
            //   ϱ ؼ
            // ׷  ,     尡 ޱ 
            //  ó  ȣ.
            doExchangePae(idString[2], idString[0], p2Whatoo.id);
            doSound("drip");
         }
      }

//      paint(getGraphics());
      repaint();

      //  ϱ
      int oldScore = playerScore[0] - playerGoCount[0];
      int currentScore = Whatoo.pointOf(tempPlayerMePaeList);

      playerScore[0] = currentScore + playerGoCount[0];

      if(myPaeList.size() == 0) {
         if(playerScore[0] >= 3) {
            String message = "560|"+idString[0]+"|ONSTOP"+"|"+playerScore[0];
            sendToServer(message);

            doProcessPoint();
            //  Ͽ ޽  DB UPDATE
         } else {
            doSetEnd();
         }
      } else {
         if(playerGoCount[0] == 0) {
            if(currentScore > oldScore) {
               doSetScore();
            }
            if(playerScore[0] >= 3) {
               doGoStop();
            }
         } else {
            if(currentScore > oldScore) {
               doSetScore();
               doGoStop();
            }
         }
      }
      playerScore[0] = currentScore + playerGoCount[0];

      return true;
   }

   public boolean mouseDown(Event evt, int x, int y) {
      int xx=0, yy=0, putPae=-1;

      if(myTurn == false) {
         return(false);
      }

      currentStep = STEP_PUT_PAE;
      if(currentStep == STEP_PUT_PAE) {
         currentStep = STEP_PUT_PAE_ING;
         if((x >= 482)&&(x <= 775)&&(y >= 414)&&(y <= 554)) {
            xx = 482 +  3;
            yy = 414 + 40;
            for(int i=0;i<myPaeList.size();i++) {
               if((x >= xx)&&(x <= (xx+Whatoo.PAE_WIDTH))&&
                  (y >= yy)&&(y <= (yy+Whatoo.PAE_HEIGHT))) {
                  putPae = i;
                  break;
               }
               xx += Whatoo.PAE_WIDTH + 3;
            }
            if(putPae != -1) {
               if(doPut(putPae) == false) {
//System.out.println("No doPut");
                  return(true);
               }
               myTurn = false;
               myFirstTurn = false;

//               reportLive();
               String message=null;
               message = "560|"+idString[0]+"|FINISHPUT";

               sendToServer(message);
            }
         }
         currentStep = STEP_NONE;
      }
      return(true);
   }

   public void doRequestPlayerList() {
      String message=null;

      message = "532|"+parentApplet.playerId;
      sendToServer(message);
   }

   public void doPaeList() {
      String message=null;

      message = "580|"+parentApplet.playerId;
      sendToServer(message);
   }

   public void doExchangePae(String fromId, String toId, int pae) {
      String message=null;

      if("$$$$".equals(fromId)) {
         message = "520";        // 512|$$$$|toId|1,2,...
      } else if("$$ٴ$$".equals(fromId)) {
         message = "512";        // 512|$$ٴ$$|toId|1,2,...
      } else if("$$⸮$$".equals(fromId)) {
         if("$$ٴ$$".equals(toId)) {
            message = "516";        // 516|$$⸮$$|$$ٴ$$|1,2,...
         } else {
            message = "518";        // 518|$$⸮$$|$$$$|1,2,...
         }
      } else {
         if("$$ٴ$$".equals(toId)) {
            message = "510";     // 510|fromId|$$ٴ$$|1,2,...
         } else {
            message = "514";     // 514|fromId|toId|1,2,...
         }
      }
      message = message+"|"+fromId+"|"+toId+"|"+pae;
      sendToServer(message);
   }

   public void doDouble(String reason) {
      String message = "560|"+idString[0]+"|DOUBLE|";

      if(("".equals(reason))||
         ("ǹ".equals(reason))||
         ("".equals(reason))||
         ("۵".equals(reason))) { // , ǹ, , ۵
         message += reason;

         sendToServer(message);
      }
   }

   public void doSetEnd() {
      String message=null;

      message = "560|"+idString[0]+"|END|"+playerScore[0];

      sendToServer(message);
   }

   void doCallSetPointAsp(String id, int point) {
      String servleturl = "http://"
                   + parentApplet.getDocumentBase().getHost()
                   + ":" + parentApplet.getDocumentBase().getHost()
                   + "/rndclub/gamepark/godori/SetPoint.jsp?id="+id+"&point="+point;
   System.out.println(servleturl);
      try {
          URL call=new URL(servleturl);
          URLConnection conn=call.openConnection();
          conn.setDoOutput(true);
          PrintWriter out=new PrintWriter(conn.getOutputStream());
          out.print(servleturl);
          out.flush();
          out.close();
      } catch(Exception e) {
         parentApplet.showStatus("Error: "+e);
         System.out.println(e);
         e.printStackTrace();
      }

//         System.out.println("DB POINT UPDATE: ["+id+","+point+"]");
   }

   void doCallSetResultAsp(String id1, int point1,
                           String id2, int point2,
                           String id3, int point3) {
       String servleturl = "http://"
                   + parentApplet.getDocumentBase().getHost()
                   + ":" + parentApplet.getDocumentBase().getHost()
                   + "/rndclub/gamepark/godori/setResult.jsp"
                   + "?winner=" + id1
                   + "&winnerPoint=" + point1
                   + "&loser1=" + id2
                   + "&loserPoint1=" + point2
                   + "&loser2=" + id3
                   + "&loserPoint2=" + point3;
System.out.println(servleturl+"2");
      try {
         URL call=new URL(servleturl);
         URLConnection conn = call.openConnection();
         conn.setDoOutput(true);

         PrintWriter out=new PrintWriter(conn.getOutputStream());
         out.print(servleturl);
         out.flush();
         out.close();
     } catch(Exception e) {
         parentApplet.showStatus("Error: "+e);
 //        System.out.println(e);
 //        e.printStackTrace();
      }
   }

   void doCallSetRunaway(String query) {
      String servletUrl = "http://"
                 + parentApplet.getDocumentBase().getHost()
                 + ":" + parentApplet.getDocumentBase().getHost()
                 + "/rndclub/gamepark/godori/SetRunaway.jsp?"+query;
      try {
         URL call=new URL(servletUrl);
         URLConnection conn = call.openConnection();

         conn.setDoOutput(true);

         PrintWriter out=new PrintWriter(conn.getOutputStream());
         out.print(query);
         out.flush();
         out.close();
      } catch(Exception e) {
         parentApplet.showStatus("Error: "+e);
         System.out.println(e);
         e.printStackTrace();
      }
//      System.out.println("doCallSetRunaway: "+servleturl);
   }

   public void doFirstSsam(int paeNo) {
      doSetPoint(idString[0],  playerPoint[0]+10);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[0], playerPoint[0]+10);

      doSetPoint(idString[1],  playerPoint[1]-5);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[1], playerPoint[1]-5);

      doSetPoint(idString[2],  playerPoint[2]-5);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[2], playerPoint[2]-5);

      doCallSetResultAsp(idString[0], 10,
                         idString[1], 5,
                         idString[2], 5);

      String message = "560|"+idString[0]+"|FIRSTSSAM|"+paeNo;
      sendToServer(message);
   }

   public void doChongTong(int paeId) {
      String message="";

      message = "560|"+idString[0]+"|WINNER|20|[ 20]";   // 10  ó
      sendToServer(message);

      message = "560|"+idString[1]+"|LOSER|10|[ 10]";    // 10  ó
      sendToServer(message);

      message = "560|"+idString[2]+"|LOSER|10|[ 10]";    // 10  ó
      sendToServer(message);

      doSetPoint(idString[0],  playerPoint[0]+20);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[0], playerPoint[0]+20);

      doSetPoint(idString[1],  playerPoint[1]-10);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[1], playerPoint[1]-10);

      doSetPoint(idString[2],  playerPoint[2]-10);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[2], playerPoint[2]-10);

      doCallSetResultAsp(idString[0], 20,
                         idString[1], 10,
                         idString[2], 10);

      message = "560|"+idString[0]+"|FINISHSESSION";    //  ó
      sendToServer(message);
   }

   public void doProcessPoint() {
      int winnerDouble=1, loserDouble1=1, loserDouble2=1;
      int winnerPoint=0, loser1Point=0, loser2Point=0;
      String message=null, winnerMsg=null;
      String loserMsg1=null, loserMsg2=null;  // Ϻη "" ʱȭ 

      if(playerSsamCount[0] == 3) {  //  Ѱɷ ..
         message = "560|"+idString[0]+"|WINNER|20|[3 ]";   // ⺻ ó
         sendToServer(message);

         message = "560|"+idString[1]+"|LOSER|10|[3 ]";    // ⺻ ó
         sendToServer(message);

         message = "560|"+idString[2]+"|LOSER|10|[3 ]";    // ⺻ ó
         sendToServer(message);

         doSetPoint(idString[0],  playerPoint[0]+20);
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[0], playerPoint[0]+20);

         doSetPoint(idString[1],  playerPoint[1]-10);
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[1], playerPoint[1]-10);

         doSetPoint(idString[2],  playerPoint[2]-10);
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[2], playerPoint[2]-10);

         doCallSetResultAsp(idString[0], 20,
                            idString[1], 10,
                            idString[2], 10);
         return;
      }

      //  Ѱ ƴѰ,  ó

      //    ó... ޽  DB   ϰ...
      winnerDouble = 1;
      winnerMsg = "";
      if(playerGoCount[0] >= 3) {
         winnerDouble *= 2;
         winnerMsg = playerGoCount[0]+",";
      }
      if(playerGoCount[0]  >= 4) {
         winnerDouble *=4;
         winnerMsg = playerGoCount[0]+",";
      }
      if(shakeFlag[0] == true) {
         winnerDouble *= 2;
         winnerMsg = winnerMsg + ",";
      }
      // ۵üũ
      if(Whatoo.isMungTta(playerMePaeList)) {
         winnerDouble *= 2;
         winnerMsg = winnerMsg + "۵,";
      }
      if((winnerMsg.length() > 0)&&(winnerMsg.endsWith(","))) {
         winnerMsg = winnerMsg.substring(0, winnerMsg.length()-1);
      }

      //   1   ó... ޽  DB ϰ...
      loserDouble1 = 1;
      loserMsg1 = winnerMsg;  // ǹ, , 

      //  1 üũ
      if(Whatoo.isKwangBak(playerMePaeList, player1PaeList)) {
         loserDouble1 *= 2;
         loserMsg1 = loserMsg1 + ",";
      }
      //  1 ǹüũ
      if(Whatoo.isPBak(playerMePaeList, player1PaeList)) {
         loserDouble1 *= 2;
         loserMsg1 = loserMsg1 + "ǹ,";
      }

      if((loserMsg1.length() > 0)&&(loserMsg1.endsWith(","))) {
         loserMsg1 = loserMsg1.substring(0, loserMsg1.length()-1);
      }

      //   2   ó... ޽  DB ϰ...
      loserDouble2 = 1;
      loserMsg2 = winnerMsg;  // ǹ, , 

      //  2 üũ
      if(Whatoo.isKwangBak(playerMePaeList, player2PaeList)) {
         loserDouble2 *= 2;
         loserMsg2 = loserMsg2 + ",";
      }
      //  2 ǹüũ
      if(Whatoo.isPBak(playerMePaeList, player2PaeList)) {
         loserDouble2 *= 2;
         loserMsg2 = loserMsg2 + "ǹ,";
      }

      if((loserMsg2.length() > 0)&&(loserMsg2.endsWith(","))) {
         loserMsg2 = loserMsg2.substring(0, loserMsg2.length()-1);
      }

      // ڽ  ޽ 
      message = "560|"+idString[0]+"|WINNER|"
              + (playerScore[0]*winnerDouble)
              + "|[" + winnerMsg + "]";
      sendToServer(message);

      // ÷̾ 1  ޽ 
      message = "560|"+idString[1]+"|LOSER|"
              + (playerScore[0]*winnerDouble*loserDouble1)
              + "|[" + loserMsg1 + "]";
      sendToServer(message);

      // ÷̾ 2  ޽ 
      message = "560|"+idString[2]+"|LOSER|"
              + (playerScore[0]*winnerDouble*loserDouble2)
              + "|[" + loserMsg2 + "]";
      sendToServer(message);

      if((playerGoCount[1] > 0)&&((playerGoCount[2] == 0))) {        // 1 
         // ÷̾ 1  ޽ 
         message = "560|"+idString[1]+"|DOKBAK|"
                 + (playerScore[0] * winnerDouble * loserDouble1
                   +playerScore[0] * winnerDouble * loserDouble2)
                 + "|[" + loserMsg1 + "], [" + loserMsg2 + "]";
         sendToServer(message);

         //  Ʈ ϱ
         loser1Point = (playerScore[0] * winnerDouble * loserDouble1);
         loser2Point = (playerScore[0] * winnerDouble * loserDouble2);

         doSetPoint(idString[1], playerPoint[1] - (loser1Point+loser2Point));
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[1], playerPoint[1]
                                        - (loser1Point+loser2Point));

         doCallSetResultAsp(idString[0], loser1Point+loser2Point,
                            idString[1], loser1Point+loser2Point,
                            idString[2], 0);
      } else if((playerGoCount[2] > 0)&&((playerGoCount[1] == 0))) { // 2 
         // ÷̾ 2  ޽ 
         message = "560|"+idString[2]+"|DOKBAK|"
                 + (playerScore[0] * winnerDouble * loserDouble1
                   +playerScore[0] * winnerDouble * loserDouble2)
                 + "|[" + loserMsg1 + "], [" + loserMsg2 + "]";
         sendToServer(message);

         //  Ʈ ϱ
         loser1Point = (playerScore[0] * winnerDouble * loserDouble1);
         loser2Point = (playerScore[0] * winnerDouble * loserDouble2);

         doSetPoint(idString[2], playerPoint[2] - (loser1Point+loser2Point));
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[2], playerPoint[2] - (loser1Point+loser2Point));

         doCallSetResultAsp(idString[0], loser1Point+loser2Point,
                            idString[1], 0,
                            idString[2], loser1Point+loser2Point);
      } else {                                                       // ھ
         loser1Point = (playerScore[0] * winnerDouble * loserDouble1);
         doSetPoint(idString[1], playerPoint[1] - loser1Point);
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[1], playerPoint[1] - loser1Point);

         loser2Point = (playerScore[0] * winnerDouble * loserDouble2);
         doSetPoint(idString[2], playerPoint[2] - loser2Point);
         // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
         doCallSetPointAsp(idString[2], playerPoint[2] - loser2Point);

         doCallSetResultAsp(idString[0], loser1Point+loser2Point,
                            idString[1], loser1Point,
                            idString[2], loser2Point);
      }
      winnerPoint = playerPoint[0] + loser1Point + loser2Point;
      doSetPoint(idString[0], winnerPoint);
      // /rndclub/gamepark/godori/SetPoint.jsp?id=xxxx&point=nnnn
      doCallSetPointAsp(idString[0], winnerPoint);

      message = "560|"+idString[0]+"|FINISHSESSION";    //  ó
      sendToServer(message);
   }

   public void doSound(String type) {
      /*
       * type: "STRIKE"|"WINNER"|"LOSER"|"SSAM"|"GO"|"STOP"|"SHAKE"
       */

      String message="560|"+idString[0]+"|SOUND|"+type;

      sendToServer(message);
   }

   public void doSsam(int paeNo) {
      String message=null;

      playerSsamCount[0]++;
      message = "560|"+idString[0]+"|SSAM|"+paeNo+"|"+playerSsamCount[0];
      sendToServer(message);

      //    ⺻ ..
      if(playerSsamCount[0] == 3) {
         message = "560|"+idString[0]+"|ONSTOP"+"|TRIPLESSAM";
         sendToServer(message);

         doProcessPoint();
      }
   }

   public void doGoStop() {
      String message=null;

      //  ó
      SelectButtonDialog s
          = new SelectButtonDialog(parentApplet.baseFrame, "Go/Stop?",
                           "GO Ǵ STOP ϼ?", "GO", "STOP");
      s.show();
      if(s.state == SelectButtonDialog.STATE_1) {
         playerGoCount[0]++;
         message = "560|"+idString[0]+"|ONGO|"
                 + playerGoCount[0]+"|"+playerScore[0];
      } else {
         message = "560|"+idString[0]+"|ONSTOP"+"|"+playerScore[0];
         doProcessPoint();   //   Ͽ ޽ 
      }

      sendToServer(message);
   }

   public void doGoDie(boolean godie) {
      String message=null;

//      System.out.println("XXXXXXXXXXXXXXXX");
      if(godie == true) { // GO
         message = "560|"+idString[0]+"|STARTGO";
      } else {             // STOP
         message = "560|"+idString[0]+"|STARTDIE";
      }
      sendToServer(message);
   }

   public void doSetScore() {
      String message=null;

      if(playerScore[0] > 0) {
         message = "560|"+idString[0]+"|SCORE|"+playerScore[0];
      }
      sendToServer(message);
   }

   public void doSetPoint(String id, int point) {
      String message=null;

      if(point > 0) {
         message = "560|"+id+"|POINT|"+point;
      }
      sendToServer(message);
   }

   public void reportLive() {
      Whatoo pae=null;
      String message=null;

      // ٴ Ʈ 
      message = "580|"+idString[0]+"|$$ٴ$$|";
      for(int i=0;i<badakPaeList.size();i++) {
         pae = (Whatoo)badakPaeList.elementAt(i);
         message += pae.id + ",";
      }
      message = message.substring(0, message.length()-1);
      sendToServer(message);

      // ù°   Ʈ 
      message = "580|"+idString[0]+"|"+idString[0]+"|";
      for(int i=0;i<playerMePaeList.size();i++) {
         pae = (Whatoo)playerMePaeList.elementAt(i);
         message += pae.id + ",";
      }
      message = message.substring(0, message.length()-1);
      sendToServer(message);

      // ι°   Ʈ 
      message = "580|"+idString[0]+"|"+idString[1]+"|";
      for(int i=0;i<player1PaeList.size();i++) {
         pae = (Whatoo)player1PaeList.elementAt(i);
         message += pae.id + ",";
      }
      message = message.substring(0, message.length()-1);
      sendToServer(message);

      // °   Ʈ 
      message = "580|"+idString[0]+"|"+idString[2]+"|";
      for(int i=0;i<player2PaeList.size();i++) {
         pae = (Whatoo)player2PaeList.elementAt(i);
         message += pae.id + ",";
      }
      message = message.substring(0, message.length()-1);
      sendToServer(message);
   }

   public void sendToServer(String message) {
      if(message != null) {
         parentApplet.sendToServer(message);
      } else {
System.out.println("ERROR: NULL WRITING");
      }
   }

   public void applyExchangePae(String fromId, String toId, String paeList) {
      Vector fromVector=null, toVector=null;

      // 𿡼 ű°?
      if("$$ٴ$$".equals(fromId)) {
         fromVector = badakPaeList;
      } else if("$$⸮$$".equals(fromId)) {
         fromVector = giriPaeList;
      } else if("$$$$".equals(fromId)) {
         fromVector = null;
      } else if(idString[0].equals(fromId)) {
         if(myTurn == true) { //   ޽ϰ,
                              //  ġ   տ п ̵
            fromVector = myPaeList;
         } else {             //   ̸  ޽ ...
                              //  ġ ִ ° ƴϸ    ..
            fromVector = playerMePaeList;
         }
      } else if(idString[1].equals(fromId)) {
         fromVector = player1PaeList;
      } else if(idString[2].equals(fromId)) {
         fromVector = player2PaeList;
      }
      //  ű°?
      if("$$ٴ$$".equals(toId)) {
         toVector = badakPaeList;
      } else if("$$⸮$$".equals(toId)) {
         toVector = giriPaeList;
      } else if("$$$$".equals(toId)) {
         toVector = null;
      } else if(idString[0].equals(toId)) {
         toVector = playerMePaeList;
      } else if(idString[1].equals(toId)) {
         toVector = player1PaeList;
      } else if(idString[2].equals(toId)) {
         toVector = player2PaeList;
      }

      try {
         StringTokenizer tokenizer = new StringTokenizer(paeList, ",");
         while(tokenizer.hasMoreTokens()) {
            int paeId = 0;
            try {
               paeId = Integer.parseInt(tokenizer.nextToken());
            } catch(NumberFormatException e) {
               continue;
            }

            if(fromVector != null) {
               fromVector.removeElement(paes[paeId]);
            }
            if(toVector != null) {
               toVector.addElement(paes[paeId]);
            }
         }
      } catch(Exception ee) {
      }
      repaint();
   }

   public void applyDistributionPae(String toId, String paeList) {
      Vector toVector=null;

      // и  °?  --> ڱ, ٴ, or ⸮
      if("$$ٴ$$".equals(toId)) {
         toVector = badakPaeList;
      } else if("$$⸮$$".equals(toId)) {
         toVector = giriPaeList;
      } else if(toId.equals(parentApplet.playerId)) {
         toVector = myPaeList;
      }
      if(toVector == null) {
         return;
      }
      try {
         StringTokenizer tokenizer = new StringTokenizer(paeList, ",");
         while(tokenizer.hasMoreTokens()) {
            int paeId = 0;
            try {
               paeId = Integer.parseInt(tokenizer.nextToken());
            } catch(NumberFormatException e) {
               continue;
            }
            toVector.addElement(paes[paeId]);
         }
      } catch(Exception ee) {
      }
      repaint();
   }

   public void applySetPlayer(String players) {
      int i=0, j=0;

      String ss[] = new String[3];
      ss[0] = "";
      ss[1] = "";
      ss[2] = "";
      try {
         displayBoard.removeAll();
         StringTokenizer tokenizer = new StringTokenizer(players, ",");
         while(tokenizer.hasMoreTokens()) {
            String name = tokenizer.nextToken();
            if(name != null) {
               if(name.startsWith("**__**")) {
                  ss[i] = name.substring(6);
                  displayBoard.add(ss[i]+" ()");
                  i++;
               } else {
                  displayBoard.add(name+" ()");
               }
            }
         }
      } catch(Exception ee) {

      }

      try {
         if(ss[0].equals(parentApplet.playerId)) {
            idString[0] = parentApplet.playerId;
            idString[1] = ss[1];
            idString[2] = ss[2];

            joinButton.setEnabled(false);
         } else if(ss[1].equals(parentApplet.playerId)) {
            idString[0] = parentApplet.playerId;
            idString[1] = ss[2];
            idString[2] = ss[0];

            joinButton.setEnabled(false);
         } else if(ss[2].equals(parentApplet.playerId)) {
            idString[0] = parentApplet.playerId;
            idString[1] = ss[0];
            idString[2] = ss[1];

            joinButton.setEnabled(false);
         } else {
            boolean x[] = new boolean[3];
            boolean y[] = new boolean[3];

            for(int ii=0;ii<3;ii++) {
               for(int jj=0;jj<3;jj++) {
                  if(idString[ii].equals(ss[jj])) {
                     x[ii] = true;
                     y[jj] = true;

                     break;
                  }
               }
            }
            for(int ii=0;ii<3;ii++) {
               if(x[ii] == false) {
                  for(int jj=0;jj<3;jj++) {
                     if(y[jj] == false) {
                        idString[ii] = ss[jj];
                        x[ii] = true;
                        y[jj] = true;
                        break;
                     }
                  }
               }
            }

            if(i < 3) {
               joinButton.setEnabled(true);
            } else {
               joinButton.setEnabled(false);
            }
         }
      } catch(Exception ee) {
      }
   }

   public void messageBoard(String message) {
      int boardX=0, boardY=0;
      int boardWidth=getSize().width, boardHeight=getSize().height;

      Font f = new Font("Batang", Font.BOLD, 15);
      FontMetrics fm = getFontMetrics(f);;

      int messageWidth = fm.stringWidth(message);
      int messageHeight = fm.getHeight();

      int rectX = ((boardWidth - messageWidth) / 2) - 20;
      int rectY = ((boardHeight - messageHeight) / 2) - 20;
      int rectWidth = messageWidth + 20 * 2;
      int rectHeight = messageHeight + 20 * 2;

      Graphics g = getGraphics();

      g.setColor(new Color(153,140,10));
      g.fillRect(rectX, rectY, rectWidth, rectHeight);    //   ׸

      g.setColor(Color.blue);
      for(int b=0;b<4;b++) {         // ׵θ ڽ ׸
         g.drawRect(rectX+b, rectY+b, rectWidth-b*2-1, rectHeight-b*2-1);
      }

      int drawX = ((boardWidth - messageWidth) / 2);
      int drawY = ((boardHeight - messageHeight) / 2) + fm.getAscent();

      g.setFont(f);
      g.drawString(message, drawX, drawY);

      try {
         Thread.sleep(1000);  // 2  ٸ.
      } catch(Exception e) {
      }

      repaint();
   }

   public void applySound(String type) {
      /*
       * type: "STRIKE"|"WINNER"|"LOSER"|"SSAM"|"GO"|"STOP"|"SHAKE"
       */

      if("STRIKE".equals(type)) {
         parentApplet.strikeAudioClip.play();
      } else if("WINNER".equals(type)) {
//       parentApplet.winnerAudioClip.play();
      } else if("LOSER".equals(type)) {
//         parentApplet.loserAudioClip.play();
      } else if("SSAM".equals(type)) {
         parentApplet.ssamAudioClip.play();
      } else if("GO".equals(type)) {
         parentApplet.goAudioClip.play();
      } else if("STOP".equals(type)) {
         parentApplet.stopAudioClip.play();
      } else if("SHAKE".equals(type)) {
         parentApplet.shakeAudioClip.play();
      } else if("drip".equals(type)) {
         parentApplet.dripAudioClip.play();
      }
      else {
         System.out.println("ERROR: Invalid Sound. [" + type + "]");
      }
//      parentApplet.strikeAudioClip.play();
   }

   public void applySsam(String who, String paeNo, String ssamCount) {
      String message = who + " :" + ssamCount + " .";

      //messageBoard(message);
      boardChatArea.append(message+"\n");
   }

   public void applyGo(String who, String goCount) {
      String message = who + " :" + goCount + "";

      //  Ʈ  ΰ?
      if(idString[0].equals(who)) {
//         ڽ  īƮ ̹(doGo)  ǾǷ,  ʿ ..
//         playerGoCount[0] = Integer.parseInt(goCount);
      } else if(idString[1].equals(who)) {
         playerGoCount[1] = Integer.parseInt(goCount);
      } else if(idString[2].equals(who)) {
         playerGoCount[2] = Integer.parseInt(goCount);
      } else {
//System.out.println("applyGo ERROR: ["+who+","+goCount+"]");
         return;
      }

   //   messageBoard(message);
        boardChatArea.append(message+"\n");
   }

   public void applyStop(String winner, String score) {
      String message=null;

      if("SSAM".equals(score)) {
         message = winner + " 3 : ⺻ 10";
      } else if("CHONGTONG".equals(score)) {
         message = winner + " Դϴ. ⺻ 10";
      } else {
         message = winner + " " + score + " ";
      }

     // messageBoard(message);
        boardChatArea.append(message+"\n");
   }

   public void applyProcessPoint(String who, String how, String howMuch, String why) {
      String message=null;

      if(idString[0].equals(who)) {
         message = " ";
      } else {
         message = who + " ";
      }
      if("WINNER".equals(how)) {
         message = message + howMuch + " Ʈ ϴ. " + why;
//       messageBoard(message);
         resultArea.append(message+"\n");
         resultArea.append("point updateԴϴ.  ٷ ּ"+"\n");
      } else if("LOSER".equals(how)) {
         message = message + howMuch + " Ʈ Ҿϴ. "+why;
//       messageBoard(message);
         resultArea.append(message+"\n");
         resultArea.append("point updateԴϴ.  ٷ ּ"+"\n");
      } else if("DOKBAK".equals(how)) {
         message = message + " "+howMuch + " Ʈ Ҿϴ. "+why;
//       messageBoard(message);
         resultArea.append(message+"\n");
         resultArea.append("point updateԴϴ.  ٷ ּ"+"\n");
      } else {
//       System.out.println("[" + who + "," + how + "," + why + "," + howMuch +"]");
      }
   }

   public void applySetEnd(String who, String score) {
   // String message = who + " " + score + " ϴ.";
      String message = who + " " + score + " .";

  //  messageBoard(message);
      boardChatArea.append(message+"\n");
   }

   public void applySetPoint(String fromId, String pointStr) {
      int whosPoint=-1;

      //  Ʈ  ΰ?
      if(idString[0].equals(fromId)) {
         whosPoint = 0;
      } else if(idString[1].equals(fromId)) {
         whosPoint = 1;
      } else if(idString[2].equals(fromId)) {
         whosPoint = 2;
      } else {
         System.out.println("SETPOINT ERROR: ["+fromId+","+pointStr+"]");

         return;
      }

      if(whosPoint != -1) {
         try {
            playerPoint[whosPoint] = Integer.parseInt(pointStr);
         } catch(NumberFormatException e) {
         }
      }
      parentApplet.playerPoint = playerPoint[0];

      repaint();
   }

   public void applySetScore(String fromId, String scoreStr) {
      int whosScore=0;

      //    ΰ?
      if(idString[0].equals(fromId)) {
         whosScore = 0;
      } else if(idString[1].equals(fromId)) {
         whosScore = 1;
      } else if(idString[2].equals(fromId)) {
         whosScore = 2;
      } else {
         System.out.println("SETPOINT ERROR: ["+fromId+","+scoreStr+"]");
         return;
      }
      if(whosScore != 0) {
         try {
            playerScore[whosScore] = Integer.parseInt(scoreStr);
         } catch(NumberFormatException e) {
         }
      }

      String message = fromId + "  " + scoreStr + "";
//    messageBoard(message);
      boardChatArea.append(message+"\n");
//    messageBoard ޼ҵ  repaint ޼ҵ带 ȣϹǷ ʿ
//    repaint();
   }

   public void applyLive(String who, String paeList) {
      Vector toVector=null;

      if("$$ٴ$$".equals(who)) {
         toVector = badakPaeList;
      } else if(idString[0].equals(who)) {
         toVector = playerMePaeList;
      } else if(idString[1].equals(who)) {
         toVector = player1PaeList;
      } else if(idString[2].equals(who)) {
         toVector = player2PaeList;
      } else {
      }
      if(toVector == null) {
         return;
      }
      toVector.removeAllElements();
      try {
         StringTokenizer tokenizer = new StringTokenizer(paeList, ",");
         while(tokenizer.hasMoreTokens()) {
            int paeId = 0;
            try {
               paeId = Integer.parseInt(tokenizer.nextToken());
            } catch(NumberFormatException e) {
               continue;
            }
            toVector.addElement(paes[paeId]);
         }
      } catch(Exception ee) {
      }
      repaint();
   }

   public void applyDoubleScore(String who, String doubleItems, String paeId) {
      try {
         if("".equals(doubleItems)) {
            doSound("SHAKE");

            if(idString[0].equals(who)) {
               shakeFlag[0] = true;
            } else if(idString[1].equals(who)) {
               shakeFlag[1] = true;
            } else if(idString[2].equals(who)) {
               shakeFlag[2] = true;
            }
            String message = null;
            if("11".equals(paeId)) {
               message = who + "  .";
            } else if("12".equals(paeId)) {
               message = who + "  .";
            } else {
               message = who + ": " + paeId + " ";
            }
//            messageBoard(message);
            boardChatArea.append(message+"\n");
         }
      } catch(Exception ee) {
      }
   }

   public String receiveMessage() throws SocketException {
      try {
         return(parentApplet.receiveMessage());
      } catch(SocketException e) {
         throw(e);
      }
   }

   public void processMessage(String receive) {
      int pae;

      //Display it.
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();

System.out.println("processMessage("+command+", "+receive+")");
      if(command != null) {
         if(command.startsWith("600")) {
            //    Commmand: 600|fromId|*|chatMessage
            // Description: äϱ
            String fromId = st.nextToken();
            String toId = st.nextToken();
            String chatStr = st.nextToken();

            boardChatArea.append(chatStr+"\n");
         } else if(command.startsWith("601")) {
            //    Commmand: 601|fromId|*|enter
            // Description: 뿡 
            String fromId = st.nextToken();

            if(fromId != null && fromId.equals(parentApplet.playerId)) {
               idString[0] = "";
               idString[1] = "";
               idString[2] = "";

               initGodori();
               initComponent();
            }
//            doRequestPlayerList();
         } else if(command.startsWith("602")) {
            //    Commmand: 602|fromId|*|join
            // Description: ϱ
            String fromId = st.nextToken();

            if(fromId != null && fromId.equals(parentApplet.playerId)) {
               initGodori();
            }
            doSetPoint(parentApplet.playerId, parentApplet.playerPoint);
            displayBoard.add(fromId+" ()");
         } else if(command.startsWith("604")) {
            //    Commmand: 604|fromId|*|exit
            // Description: 
            String fromId = st.nextToken();

            try {
               displayBoard.remove(fromId);
            } catch(IllegalArgumentException e) {
            }
        } else if(command.startsWith("606")) { //޽ ó
            // Command : 606|toID|Message
            String fromId=st.nextToken();
            String mesg=st.nextToken();

            messageBoard(mesg);
         } else if(command.startsWith("610")||
                   //    Commmand: 610|fromID|$$ٴ$$|1,2,...
                   // Description: бȯ (->ٴ)
                   command.startsWith("612")||
                   //    Commmand: 612|$$ٴ$$|toID|1,2,...
                   // Description: бȯ (ٴ->)
                   command.startsWith("614")||
                   //    Commmand: 614|fromID|toID|1,2,...
                   // Description: бȯ (1->2)
                   command.startsWith("616")||
                   //    Commmand: 616|$$⸮$$|$$ٴ$$|1,2,...
                   // Description: бȯ (⸮->ٴ)
                   command.startsWith("618")||
                   //    Commmand: 618|$$⸮$$|$$$$|1,2,...
                   // Description: бȯ (⸮->$$$$)
                   command.startsWith("620")) {
                   //    Commmand: 620|$$$$|[toId|$$ٴ$$]|1,2,...
                   // Description: бȯ ($$$$-> or ٴ)
            String fromId = st.nextToken();  // It should be "$$$$".
            String toId = st.nextToken();    // It should be toId or "$$ٴ$$".
            String paeList = st.nextToken();

            // бȯ (⸮->NONE) ó
            applyExchangePae(fromId, toId, paeList);
         } else if(command.startsWith("630")) {
            //    Commmand: 630|[toId|$$ٴ$$|$$⸮$$]|1,2,...
            // Description: г (ڱorٴor⸮) ó
            String toId = st.nextToken();    // It should be ID of you, "$$ٴ$$", or "$$⸮$$".
            String paeList = st.nextToken();

            // г (ڱorٴor⸮)
            applyDistributionPae(toId, paeList);
         } else if(command.startsWith("632")) {
            //    Commmand: 632|*|1,2,...
            // Description:  Ʈ
            String toId = st.nextToken();    // It should be "*".
            String players = st.nextToken();
            /*
             * ܾտ "**__**"     ̴..
             */

            // г (ڱorٴor⸮)
            applySetPlayer(players);
         } else if(command.startsWith("650")) {
            //    Commmand: 650|toId|[GO/DIE?| STARTSESSION
            //                               | FINISHSESSION
            //                               | TURN
            //                               | GO/STOP?]|"TURN"  ش ID
            //    Commmand: 650|toId|GO/DIE?
            //    Commmand: 650|toId|GO/STOP?
            //    Commmand: 650|*|STARTSESSION
            //    Commmand: 650|*|FINISHSESSION
            //    Commmand: 650|*|WAITINGSESSION
            //    Commmand: 650|toId|TURN|id
            // Description: 1 (go/die , ĥ, go/stop , )
            String toId = st.nextToken();
            String type = st.nextToken();
            // It should be "GO/DIE?", "STARTSESSION",
            //              "FINISHSESSION", "TURN", or "GO/STOP?".

            // 1 (go/die , ĥ, go/stop ) ó
            if("GO/DIE?".equals(type)) {
               // GO/DIE θ  ̾α ڽ Ÿ,
               // GO/DIE    
               if(idString[0].equals(parentApplet.playerId)||
                  idString[1].equals(parentApplet.playerId)||
                  idString[2].equals(parentApplet.playerId)) {
                  doGoDie(true);
               }
/*
               if(toId.equals(parentApplet.playerId)) {
                  doGoDie(true);
               }
*/
            } else if("STARTSESSION".equals(type)) {
               //  ̼  ġ 
               if(idString[0].equals(parentApplet.playerId)||
                  idString[1].equals(parentApplet.playerId)||
                  idString[2].equals(parentApplet.playerId)) {
                  joinButton.setEnabled(false);
                  exitButton.setEnabled(false);
                  doSetPoint(parentApplet.playerId, parentApplet.playerPoint);
               } else {
                  joinButton.setEnabled(false);
                  exitButton.setEnabled(true);
               }

               onSession = true;
               firstTurn = true;
               myFirstTurn = true;

               //messageBoard(" մϴ.");
               boardChatArea.append("\n"+"    "+" մϴ."+"\n");
               resultArea.append("   "+" ӿ  Ʈ  â Դϴ."+"\n");
            } else if("FINISHSESSION".equals(type)) {
               //  ̼  ġ 
               if(idString[0].equals(parentApplet.playerId)||
                  idString[1].equals(parentApplet.playerId)||
                  idString[2].equals(parentApplet.playerId)) {
                  joinButton.setEnabled(false);
                  exitButton.setEnabled(true);
               }

               reset();

               onSession = false;
//               messageBoard(" ϴ.");
//               boardChatArea.append(message);

//               doSetPoint(parentApplet.playerId, parentApplet.playerPoint);
            } else if("WAITINGSESSION".equals(type)) {
               // ġ    ֵ  ش...
               if(idString[0].equals(parentApplet.playerId)||
                  idString[1].equals(parentApplet.playerId)||
                  idString[2].equals(parentApplet.playerId)) {
                  joinButton.setEnabled(false);
                  exitButton.setEnabled(true);
               }

               messageBoard("׸ Ͻ÷  ư . (5)");
            } else if("JOINSESSION".equals(type)) {
               // ġ    ֵ  ش..
               if(!idString[0].equals(parentApplet.playerId)&&
                  !idString[1].equals(parentApplet.playerId)&&
                  !idString[2].equals(parentApplet.playerId)) {
                  joinButton.setEnabled(true);
               }

               joinButton.setEnabled(true);
          //     messageBoard(" Ͻ÷ ϱ ư ...");
            } else if("TURN".equals(type)) {
               //  ʸ ȰȭϿ ڰ и ϵ .
               String ownerTurn = st.nextToken();    // ID who owns turn

               if(parentApplet.playerId.equals(ownerTurn)) {
                  myTurn = true;
               }
               if(idString[0].equals(ownerTurn)) {
                  // ù°  ĥ  ǥѴ.
                  turnOwner = 0;
               } else if(idString[1].equals(ownerTurn)) {
                  // ι°  ĥ  ǥѴ.
                  turnOwner = 1;
               } else if(idString[2].equals(ownerTurn)) {
                  // °  ĥ  ǥѴ.
                  turnOwner = 2;
               }

               if(firstTurn == true) {
                  doSetPoint(parentApplet.playerId, parentApplet.playerPoint);

                  shakeCheck();
                  chongTongCheck();
                  if(myTurn == true) {  // ڽ  ..
                     // ó ġ  ̰, ٴڿ Ŀ 
                     //  Ŀ , ⸮и  ѱ..
                     // ٴп ¥ ִ ˻Ͽ ڽ() ´..
                     jokerInBadak(turnOwner);
                  }
                  firstTurn = false;
               }
               repaint();
/*
               if(myTurn == true) {
                  int restTime = 60;   //  5  ش.
                  while((myTurn == true)&&(restTime > 0)) {
                     try {
                        Thread.sleep(100);
                     } catch(InterruptedException e) {
                     }
                     restTime--;
                  }
                  messageBoard("3  ֽϴ. и  ..");
   System.out.println("TURN1: "+myTurn+", "+restTime);
                  restTime = 30;   //  3   ش.
                  while((myTurn == true)&&(restTime > 0)) {
                     try {
                        Thread.sleep(100);
                     } catch(InterruptedException e) {
                     }
                     restTime--;
                  }
   System.out.println("TURN2: "+myTurn+", "+restTime);
                  if(myTurn == true) {
                     doPut(0);
   System.out.println("doPut: "+myTurn+", "+restTime);
                     myTurn = false;

                     String message=null;
                     message = "560|"+idString[0]+"|FINISHPUT";

                     sendToServer(message);
                  }
   System.out.println("TURN3: "+myTurn+", "+restTime);
               }
               repaint();
*/

            } else if("GO/STOP?".equals(type)) {
               // GO/STOP θ  ̾α ڽ Ÿ,
               // GO/STOP    

               doGoStop();
            } else {
               System.out.println("COMMAND 650 (1) ERROR: ["+toId+","+type+"]");
            }
         } else if(command.startsWith("660")) {
            //    Commmand: 660|fromId|STARTGO
            //    Commmand: 660|fromId|STARTDIE
            //    Commmand: 660|fromId|ONGO|goCount|score
            //    Commmand: 660|fromId|ONSTOP|[score|"SSAM"
            //    Commmand: 660|fromId|END|score
            //    Commmand: 660|fromId|SSAM|ssamCount
            //    Commmand: 660|fromId|FIRSTSSAM|pae
            //    Commmand: 660|fromId|SCORE|score
            //    Commmand: 660|fromId|POINT|point
            //    Commmand: 660|fromId|WINNER|point|DOUDBLE_MSG
            //    Commmand: 660|fromId|LOSER|point|DOUDBLE_MSG
            //    Commmand: 660|fromId|DOKBAK|point|DOUDBLE_MSG
            //    Commmand: 660|fromId|SOUND|type=["STRIKE"|"WINNER"|"LOSER"|
            //                                     "SSAM"|"GO"|"STOP"|"SHAKE"]
            //    Commmand: 660|fromId|DOUBLE||
            String fromId = st.nextToken();
            String type = st.nextToken();

            if("STARTGO".equals(type)) {
               //  ġ(GO) ó - ʿ ǹ ???
               //    Commmand: 660|fromId|STARTGO
            } else if("STARTDIE".equals(type)) {
               //  ױ(GO) ó - ʿ ǹ ???
               //    Commmand: 660|fromId|STARTDIE
            } else if("ONGO".equals(type)) {
               // GO ó - 1, 2, 3  ó
               //    Commmand: 660|fromId|ONGO|goCount|score
               String goCount = st.nextToken();
               String score = st.nextToken();

               doSound("GO");
               applyGo(fromId, goCount);
            } else if("ONSTOP".equals(type)) {
               //    Commmand: 660|fromId|ONSTOP|[score|"SSAM"|"CHONGTONG"]
               String score = st.nextToken();

               myTurn = false;

               doSound("STOP");
               applyStop(fromId, score);
            } else if("SSAM".equals(type)) {
               //    Commmand: 660|fromId|SSAM|paeNo|ssamCount
               String paeNo = st.nextToken();
               String ssamCount = st.nextToken();

               doSound("SSAM");
               applySsam(fromId, paeNo, ssamCount);
            } else if("FIRSTSSAM".equals(type)) {
               //    Commmand: 660|fromId|FIRSTSSAM|paeNo
               String paeNo = st.nextToken();

               doSound("SSAM");
// messageBoard("["+fromId+"]  ["+paeNo+"] и ù߽ϴ..");
               resultArea.append("["+fromId+"]  ["
                                +paeNo+"] и ù߽ϴ.."+"\n");
               resultArea.append("["+fromId
                                +"] Կ 5 10 帳ϴ.."+"\n");
            } else if("END".equals(type)) {
               //    Commmand: 660|fromId|END|score
               String score = st.nextToken();

               applySetEnd(fromId, score);
            } else if("DOUBLE".equals(type)) {
               //    Commmand: 660|fromId|DOUBLE||
               String doubleItems = st.nextToken();
               String paeId = st.nextToken();

               applyDoubleScore(fromId, doubleItems, paeId);  // 
            } else if(type.startsWith("SCORE")) {
               //    Commmand: 660|fromId|SCORE|score
               String score = st.nextToken();    //   ó

               //   ó
               applySetScore(fromId, score);
            } else if(type.startsWith("POINT")) {
               //    Commmand: 660|fromId|POINT|point
               String point = st.nextToken();    //  Ʈ 

               //  Ʈ 
               applySetPoint(fromId, point);
            } else if(type.startsWith("WINNER")) {
               //    Commmand: 660|fromId|WINNER|point|DOUDBLE_MSG
               String point = st.nextToken();      //  
               String doubleMsg = st.nextToken();  // 2 ýũ

               //doSound("WINNER");
               applyProcessPoint(fromId, type, point, doubleMsg);
            } else if(type.startsWith("LOSER")) {
               //    Commmand: 660|fromId|LOSER|point|DOUDBLE_MSG
               String point = st.nextToken();      //   (=Ʈ)
               String doubleMsg = st.nextToken();  // 2 ýũ

               //doSound("LOSER");
               applyProcessPoint(fromId, type, point, doubleMsg);
            } else if(type.startsWith("DOKBAK")) {
               //    Commmand: 660|fromId|LOSER|point|DOUDBLE_MSG
               String point = st.nextToken();      //   (=Ʈ)
               String doubleMsg = st.nextToken();  // 2 ýũ

               //doSound("DOKBAK");
               applyProcessPoint(fromId, type, point, doubleMsg);
            } else if(type.startsWith("SOUND")) {
               //    Commmand: 660|fromId|SOUND|type=["STRIKE"|"WINNER"|"LOSER"|
               //                                     "SSAM"|"GO"|"STOP"|"SHAKE"]
               String soundType = st.nextToken();

               applySound(soundType);
            } else if(type.startsWith("ANIMATEPUT")) {
               //    Commmand: 660|fromId|ANIMATEPUT|putPae,x,y,c
               String parameter = st.nextToken();
               if(!fromId.equals(parentApplet.playerId)) {
                  StringTokenizer sst = new StringTokenizer(parameter, ",");

                  int putPae=0, x=0, y=0, c=1;

                  try {
                     putPae = Integer.parseInt(sst.nextToken());
                  } catch(Exception e) {
                     System.out.println("AnimatePut: "+e);
                  }
                  try {
                     x = Integer.parseInt(sst.nextToken());
                  } catch(Exception e) {
                     System.out.println("AnimatePut: "+e);
                  }
                  try {
                     y = Integer.parseInt(sst.nextToken());
                  } catch(Exception e) {
                     System.out.println("AnimatePut: "+e);
                  }
                  try {
                     c = Integer.parseInt(sst.nextToken());
                  } catch(Exception e) {
                     System.out.println("AnimatePut: "+e);
                  }

                  applyAnimatePut(putPae, x, y, c);
               }
            } else {
               System.out.println("COMMAND 660 (2) ERROR: ["
                                 +fromId+","+type+"]");
            }
         } else if(command.startsWith("680")) {
            //    Commmand: 680|fromId|[$$ٴ$$|p0Id|p1Id|p2Id]|1,2,...
            // Description:
            String fromId = st.nextToken();
            String who = st.nextToken();
            String paeList = st.nextToken();

            if(idString[0] == null || "".equals(idString[0])) {
               doRequestPlayerList();
               doPaeList();
            } else {
               if(!idString[0].equals(parentApplet.playerId)&&
                  !idString[1].equals(parentApplet.playerId)&&
                  !idString[2].equals(parentApplet.playerId)) {
                  applyLive(who, paeList);
               }
            }
         } else if(command.startsWith("684")) {
            //    Commmand: 684|toId||id1,id2,...
            // Description:
            String playerId = st.nextToken();
            String roomId = st.nextToken();
            String idList = st.nextToken();

            InvitationDialog ii
                    = new InvitationDialog(parentApplet.baseFrame,
                                     this, playerId, idList);
            ii.show();
         } else if(command.startsWith("688")) {
            //    Commmand: 688|fromId|toId|roomId|[JOIN|REFUSE|EMPTY]
            // Description:
            String fromId = st.nextToken();
            String toId = st.nextToken();
            String roomId = st.nextToken();
            String joinRefuse = st.nextToken();
            String message="";

System.out.println("688: "+receive);

            if("JOIN".equals(joinRefuse)) {
               message = "["+fromId+"] Բ ʴ뿡 ϼ̽ϴ..";
            } else if("REFUSE".equals(joinRefuse)) {
               message = "["+fromId+"] Բ ʴ븦 ϼ̽ϴ..";
            } else if("EMPTY".equals(joinRefuse)) {
               message = "ǿ ƹ ϴ..";
            }
            if(!"".equals(message)) {
               messageBoard(message);
            }
         } else if(command.startsWith("690")) {
            //    Commmand: 690|toId|URLString
            // Description:
            String fromId = st.nextToken();
            String url = st.nextToken();

            doCallSetRunaway(url);
         }
      }
   }
}
