/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.awt.*;

public class ImageCanvas extends Canvas {
   Container pappy;
   Image image;
   boolean trueSizeKnown = false;
   Dimension minSize;
   int width, height;

   public ImageCanvas(Image image, Container parent, int width, int height) {
      if (image == null) {
         System.err.println("Canvas got invalid image object!");
         return;
      }

      // ̹ Ʈ  Ƽ 
      this.image = image;
      pappy = parent;
      this.width = width;
      this.height = height;

      // ̹ Ʈ ּ ũ⸦ ־ ũ 
      minSize = new Dimension(width, height);
   }

   // ̹ Ʈ ̾ƿ ϱ  ̾ƿ ڷκ ȣǴ ޼ҵ̴.
   // , preferredSize() ޼ҵ带 Ͽ Ʈ  ũ⸦ Ѵ.
   public Dimension preferredSize() {
      return minimumSize();
   }

   // ̹ Ʈ ̾ƿ ϱ  ̾ƿ ڷκ ȣǴ ޼ҵ̴.
   // , minimumSize () ޼ҵ带 Ͽ Ʈ ּ ũ⸦ Ѵ.
   public synchronized Dimension minimumSize() {
      return minSize;
   }

   public void setImage(Image image) {
      this.image = image;
      repaint();
   }

   // ̹ ŸǷ   ּȭϱ  update() ޼ҵ 
   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      if(image != null) {
         if(!trueSizeKnown) {
            int imageWidth = image.getWidth(this);
            int imageHeight = image.getHeight(this);
            // ̹  Ǿ 쿡 ׷ش.
            if ((imageWidth > 0) && (imageHeight > 0)) {
               trueSizeKnown = true;
               width = imageWidth;
               height = imageHeight;
               minSize = new Dimension(width, height);
               setSize(width, height);
               pappy.doLayout();
               pappy.repaint();
            }
         }
         // ׵θ ׸  ̹ ׷ش.
         g.drawRect(0, 0, width - 1, height - 1);
         g.drawImage(image, 0, 0, this);
      }
   }
}
